
/******************************************************************************
*	File Class Source
******************************************************************************/

#include "stdafx.h"
using namespace selna;


/*----------------------------------------------------------------------------*
|	RXgN^
*----------------------------------------------------------------------------*/
CFile::CFile()
{

	m_lpFile  = NULL;

}


/*----------------------------------------------------------------------------*
|	RXgN^2
*----------------------------------------------------------------------------*/
CFile::CFile( const char* lpszFileName, const char *lpMode )
{

	m_lpFile = NULL;

	Open( lpszFileName, lpMode );

}


/*----------------------------------------------------------------------------*
|	fXgN^
*----------------------------------------------------------------------------*/
CFile::~CFile()
{
	
	Close();

}


/*----------------------------------------------------------------------------*
|	I[v
*----------------------------------------------------------------------------*/
void CFile::Open( const char* lpszFileName, const char* lpMode )
{
	
	if( m_lpFile != NULL ) return;

	m_lpFile = ::fopen( lpszFileName, lpMode );
	
	if( m_lpFile )
	{
		// t@CtpX擾
		char szFullPath[ MAX_PATH ];
		::GetFullPathName( lpszFileName, MAX_PATH, szFullPath, NULL );
		m_strFullPathName = szFullPath;

		// I[v[hݒ
		m_strOpenMode = lpMode;

	}
}


/*----------------------------------------------------------------------------*
|	N[Y
*----------------------------------------------------------------------------*/
void CFile::Close( void )
{

	if( m_lpFile == NULL ) return;

	::fclose( m_lpFile );

	m_lpFile = NULL;

	m_strFullPathName.empty();

	m_strOpenMode.empty();
}


/*----------------------------------------------------------------------------*
|	t@CTCY擾
*----------------------------------------------------------------------------*/
DWORD CFile::GetSize( void )
{

	long nSave = GetPosition();

	SeekToEnd();

	DWORD dwSize = (DWORD)GetPosition();

	Seek( nSave, SEEK_SET );

	return dwSize;

}


/*----------------------------------------------------------------------------*
|	t@C擾
*----------------------------------------------------------------------------*/
string CFile::GetFileName( void )
{

	if( m_strFullPathName.length() == 0 ) return "";

	char szName[ _MAX_FNAME ], szExt[ _MAX_EXT ], szFileName[ _MAX_FNAME ];
	
	::_splitpath( m_strFullPathName.c_str(), NULL, NULL, szName, szExt );
	
	::_makepath( szFileName, NULL, NULL, szName, szExt );

	return szFileName;

}


/*----------------------------------------------------------------------------*
|	t@CfBNg擾
*----------------------------------------------------------------------------*/
string CFile::GetFileDir( void )
{
	if( m_strFullPathName.length() == 0 ) return "";

	char szPathDir[ _MAX_FNAME ], szDir[ _MAX_DIR ], szDrive[ _MAX_DRIVE ];

	::_splitpath( m_strFullPathName.c_str(), szDrive, szDir, NULL, NULL );

	::_makepath( szPathDir, szDrive, szDir, NULL, NULL );

	return szPathDir;

}


/*----------------------------------------------------------------------------*
|	t@Cgq擾
*----------------------------------------------------------------------------*/
string CFile::GetFileExt( void )
{

	if( m_strFullPathName.length() == 0 ) return "";

	char szExt[ _MAX_EXT ];

	::_splitpath( m_strFullPathName.c_str(), NULL, NULL, NULL, szExt );

	return szExt;

}


/*----------------------------------------------------------------------------*
|	t@CԎ擾
*----------------------------------------------------------------------------*/
BOOL CFile::GetFileTime( LPSYSTEMTIME lpCreationTime, LPSYSTEMTIME lpLastAccessTime, LPSYSTEMTIME lpLastWriteTime )
{
	
	if( m_strFullPathName.length() == 0 ) return FALSE;


	// t@Cnh쐬
	// łɃt@CI[vĂ̂œǂݏ[hLŃI[v
	HANDLE hFile = ::CreateFile( 
		m_strFullPathName.c_str(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

	if( hFile == NULL ) return FALSE;

	FILETIME ct, lt, wt;
	BOOL ret = FALSE;

	// t@CԎ擾
	if( ::GetFileTime( hFile, &ct, &lt, &wt ) )
	{
		// t@CԁVXeԂɕϊ
		if( lpCreationTime )
		{
			::FileTimeToLocalFileTime( &ct, &ct );
			::FileTimeToSystemTime( &ct, lpCreationTime );
		}

		if( lpLastAccessTime )
		{
			::FileTimeToLocalFileTime( &lt, &lt );
			::FileTimeToSystemTime( &lt, lpLastAccessTime );
		}

		if( lpLastWriteTime )
		{
			::FileTimeToLocalFileTime( &wt, &wt );
			::FileTimeToSystemTime( &wt, lpLastWriteTime );
		}

		ret = TRUE;
	}

	// t@Cnh
	::CloseHandle( hFile );

	return ret;

}


/*----------------------------------------------------------------------------*
|	t@CԐݒ
*----------------------------------------------------------------------------*/
BOOL CFile::SetFileTime( LPSYSTEMTIME lpCreationTime, LPSYSTEMTIME lpLastAccessTime, LPSYSTEMTIME lpLastWriteTime )
{
	
	if( m_strFullPathName.length() == 0 ) return FALSE;

	// t@Cnh쐬
	// łɃt@CI[vĂ̂œǂݏ[hLŃI[v
	HANDLE hFile = ::CreateFile( 
		m_strFullPathName.c_str(), GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

	if( hFile == NULL ) return FALSE;

	auto_ptrEx<FILETIME> pCt, pLt, pWt;
	BOOL ret = FALSE;

	// VXeԁt@CԂɕϊ
	if( lpCreationTime )
	{
		pCt = auto_ptrEx<FILETIME>( new FILETIME );
		::SystemTimeToFileTime( lpCreationTime, pCt );
		::LocalFileTimeToFileTime( pCt, pCt );
	}

	if( lpLastAccessTime )
	{
		pLt = auto_ptrEx<FILETIME>( new FILETIME );
		::SystemTimeToFileTime( lpLastAccessTime, pLt );
		::LocalFileTimeToFileTime( pLt, pLt );
	}

	if( lpLastWriteTime )
	{
		pWt = auto_ptrEx<FILETIME>( new FILETIME );
		::SystemTimeToFileTime( lpLastWriteTime, pWt );
		::LocalFileTimeToFileTime( pWt, pWt );
	}

	// t@Cԏ
	if( ::SetFileTime( hFile, pCt, pLt, pWt ) )
	{
		ret = TRUE;
	}

	// t@Cnh
	::CloseHandle( hFile );

	return ret;

}


/*----------------------------------------------------------------------------*
|	݂̃t@C|WVEOFɂ
*----------------------------------------------------------------------------*/
BOOL CFile::SetEOF( void )
{

	if( m_strFullPathName.length() == 0 ) return FALSE;

	// t@Cnh쐬
	// łɃt@CI[vĂ̂œǂݏ[hLŃI[v
	HANDLE hFile = ::CreateFile( 
		m_strFullPathName.c_str(), GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

	if( hFile == NULL ) return FALSE;

	::SetFilePointer( hFile, GetPosition(), NULL, FILE_BEGIN );

	BOOL ret = ::SetEndOfFile( hFile );

	// t@Cnh
	::CloseHandle( hFile );

	return ret;

}
