
/******************************************************************************
*	SDIB32GLBase Class
******************************************************************************/

#include "stdafx.h"
#include "sdib32gl.h"
#include "sdib32glbase.h"


// 32rbg64rbgɂ}N
#define SDIB32GL_INT32ToINT64( high, low, v )	__asm		\
{															\
	__asm mov eax, v										\
	__asm cdq												\
	__asm mov high, edx										\
	__asm mov low,	eax										\
}

// 64rbg𕄍]}N
#define SDIB32GL_NEG64( high, low )		__asm	\
{												\
	__asm neg low								\
	__asm adc high, 0							\
	__asm neg high								\
}

// 64rbgm̑Z
#define SDIB32GL_ADD64( c_high, c_low, a_high, a_low, b_high, b_low )	__asm	\
{																				\
	__asm mov eax, a_low														\
	__asm mov ebx, a_high														\
	__asm add eax, b_low														\
	__asm adc ebx, b_high														\
	__asm mov c_low,  eax														\
	__asm mov c_high, ebx														\
}


// 64rbgm̈Z
#define SDIB32GL_SUB64( c_high, c_low, a_high, a_low, b_high, b_low )	__asm	\
{																				\
	__asm mov eax, a_low														\
	__asm mov ebx, a_high														\
	__asm sub eax, b_low														\
	__asm sbb ebx, b_high														\
	__asm mov c_low,  eax														\
	__asm mov c_high, ebx														\
}

// Œ菬𐮐Əɕ
#define SDIB32GL_DIVIDEFIXED64( a_high, a_low )	__asm	\
{														\
	__asm mov eax, a_low								\
	__asm shld a_high, eax, 16							\
	__asm shl a_low, 16									\
}


SDIB32GLCOLOR	CSDib32GLBase::m_MonoTbl[256];


/*----------------------------------------------------------------------------*
|	RXgN^
*----------------------------------------------------------------------------*/
CSDib32GLBase::CSDib32GLBase() : 
m_hBitmap( NULL ),
m_hMemDC( NULL ),
m_SorceDC( NULL ),
m_pBits( NULL ),
m_ppScanLine( NULL ),
m_dwSizeImage( 0 ), 
m_nWidth( 0 ),
m_nHeight( 0 ),
m_ColorKey( 0xFF000000 ),
m_ulRef( 1 )
{
	m_szFilePath[0] = '\0';
	ZeroMemory( &m_rcClip, sizeof(RECT));
	::SDIB32GL_DebugOutput("  new     : Adr=0x%08X, Ref=%d;\n", this, m_ulRef );
}


/*----------------------------------------------------------------------------*
|	fXgN^
*----------------------------------------------------------------------------*/
CSDib32GLBase::~CSDib32GLBase()
{

	SAFE_DELETE_ARRAY( m_ppScanLine );	// XLCobt@
	SAFE_DELETE_DC( m_hMemDC );			// DC
	SAFE_DELETE_OBJECT( m_hBitmap );	// rbg}bvnh

	::SDIB32GL_DebugOutput("  del     : Adr=0x%08X, Ref=%d;\n", this, m_ulRef );
}


/*----------------------------------------------------------------------------*
|	C^[tFCXv(IUnknown\bh)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::QueryInterface( REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject )
{

	if( ::IsEqualIID( riid, IID_IUnknown ) )
	{
		// version 1̃C^[tFCXɃAbvLXg
		*ppvObject = static_cast<ISDib32GL*>(this);

	}else if( ::IsEqualIID( riid, IID_ISDib32GL ) )
	{
		// version 1̃C^[tFCXɃAbvLXg
		*ppvObject = static_cast<ISDib32GL*>(this);

/*	}else if( ::IsEqualIID( riid, IID_ISDib32GL2 ) )
	{
		// version 2̃C^[tFCXɃAbvLXg
		*ppvObject = static_cast<ISDib32GL2*>(this);
*/
	}else
	{
		// w肳ꂽC^[tFCX݂͑Ȃ
		*ppvObject = NULL;
		return E_NOINTERFACE;
	}

	AddRef();

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	QƃJE^(IUnknown\bh)
*----------------------------------------------------------------------------*/
STDMETHODIMP_( ULONG ) CSDib32GLBase::AddRef( void )
{

	m_ulRef++;
	
	::SDIB32GL_DebugOutput("  AddRef  : Adr=0x%08X, Ref=%d;\n", this, m_ulRef );

	return m_ulRef;
}


/*----------------------------------------------------------------------------*
|	QƃJE^IUnknown\bh)
*----------------------------------------------------------------------------*/
STDMETHODIMP_( ULONG ) CSDib32GLBase::Release( void )
{

	if( --m_ulRef > 0 )
	{
		::SDIB32GL_DebugOutput("  Release : Adr=0x%08X, Ref=%d;\n", this, m_ulRef );

		return m_ulRef;
	}

	delete this;

	return 0;
}


/*----------------------------------------------------------------------------*
|	t@Cǂݍ
|
|	ΉsN`t@C32bitDIBɕϊēǂݍ݂܂
|
|	ΉsN`t@C: 
|	Bitmap(8,24,32)ATarga(8,8+Alpha,24,32)AJpegAPNG(8,24,32)
|
|	[]
|	const char* lpszFileNamecǂݍރt@C
|	SDIB32GLCOLOR ColorKeycߐF(ftHgł͍)
|	HDC hdccDC̍쐬ΏۂłfoCXDC(ʏNULLw)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::LoadFromFile( const char* lpszFileName, SDIB32GLCOLOR ColorKey, HDC hdc )
{
	_ASSERTE( m_pBits == NULL );
	if( m_pBits != NULL ) return SDIB32GLERR_SDIB32GLALREADYCREATED;

	CGraphicLoader gl;
	
	try
	{
		// sN`ǂݍ
		gl.LoadPicture( lpszFileName );

		int nBitCount;

		LPBITMAPINFO lpBmpInfo = (LPBITMAPINFO)::LocalLock( gl.GetHBmpInfo() );
		{
			if( !lpBmpInfo ) return SDIB32GLERR_OUTOFMEMORY;

			nBitCount = lpBmpInfo->bmiHeader.biBitCount;

		}
		::LocalUnlock( gl.GetHBmpInfo() );

		// ꉞrbg`FbN
		if( nBitCount != 8 && nBitCount != 24 && nBitCount != 32 )

			return SDIB32GLERR_UNSUPPORTEDBITCOUNT;
	}

	catch( exception& e )
	{
		if( strcmp( e.what(), "File Not Found" ) == 0 )
		{
			return SDIB32GLERR_FILENOTFOUND;
		}else if( strcmp( e.what(), "bad allocation" ) == 0 )
		{
			return SDIB32GLERR_OUTOFMEMORY;
		}

		return SDIB32GLERR_UNSUPPORTEDFILE;
	}

	catch( ... ) { return SDIB32GLERR_EXCEPTION; }

	// sN`̃TCY擾
	SIZE size;
	gl.GetSize( &size );

	// obt@쐬
	HRESULT hr = CreateBuffer( size.cx, size.cy, SDIB32GL_XRGB(0,0,0), hdc );

	if( FAILED(hr) ) return hr;

	// obt@Ƀ_O
	gl.Render( m_pBits, GL_GETBMPROWBYTES(size.cx,4), GLFMT_A8R8G8B8 );

	// tpXɂ
	::GetFullPathName( lpszFileName, 256, m_szFilePath, NULL );
	
	// J[L[ݒ
	m_ColorKey = ColorKey;

	::SDIB32GL_DebugOutput( " +- LoadFromFile    : Adr=0x%08X, File=\"%s\";\n", this, lpszFileName );

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	t@Cǂݍ EX
|
|	ΉOtBbNt@C32bitDIBɕϊēǂݍ݂܂
|	t@CItZbgw肷邱ƂɂāAǂ̈ʒuɉ摜f[^Ă
|	o郁bg܂B
|	SPIvOCfBNgw肷邱ƂɂėpłSPI
|	t@CǂݍނƂł܂B
|
|	ΉsN`t@C: 
|	Bitmap(8,24,32)ATarga(8,8+Alpha,24,32)AJpegAPNG(8,24,32)
|	SPIvOC̓ǂݍ(͂܂T|[gĂȂ)
|
|	[]
|	const char* lpszFileNamecǂݍރt@C
|	DWORD dwOffsetct@CItZbg
|	const char* lpszSpiDircSPIvOĈfBNg(NULLwŃftHgǂݍ)
|	SDIB32GLCOLOR ColorKeycߐF(ftHgł͍)
|	HDC hdccDC̍쐬ΏۂłfoCXDC(ʏNULLw)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::LoadFromFileEx( const char* lpszFileName, DWORD dwOffset, const char* lpszSpiDir, SDIB32GLCOLOR ColorKey, HDC hdc )
{

	_ASSERTE( m_pBits == NULL );
	if( m_pBits != NULL ) return SDIB32GLERR_SDIB32GLALREADYCREATED;

	CGraphicLoader gl;
	
	try
	{
		// sN`ǂݍ
		gl.LoadPicture( lpszFileName, dwOffset, lpszSpiDir );

		int nBitCount;

		LPBITMAPINFO lpBmpInfo = (LPBITMAPINFO)::LocalLock( gl.GetHBmpInfo() );
		{
			if( !lpBmpInfo ) return SDIB32GLERR_OUTOFMEMORY;

			nBitCount = lpBmpInfo->bmiHeader.biBitCount;

		}
		::LocalUnlock( gl.GetHBmpInfo() );

		// ꉞrbg`FbN
		if( nBitCount != 8 && nBitCount != 24 && nBitCount != 32 )

			return SDIB32GLERR_UNSUPPORTEDBITCOUNT;
	}

	catch( exception& e )
	{
		if( strcmp( e.what(), "File Not Found" ) == 0 )
		{
			return SDIB32GLERR_FILENOTFOUND;
		}else if( strcmp( e.what(), "bad allocation" ) == 0 )
		{
			return SDIB32GLERR_OUTOFMEMORY;
		}

		return SDIB32GLERR_UNSUPPORTEDFILE;
	}

	catch( ... ) { return SDIB32GLERR_EXCEPTION; }

	// sN`̃TCY擾
	SIZE size;
	gl.GetSize( &size );

	// obt@쐬
	HRESULT hr = CreateBuffer( size.cx, size.cy, SDIB32GL_XRGB(0,0,0), hdc );

	if( FAILED(hr) ) return hr;

	// obt@Ƀ_O
	gl.Render( m_pBits, GL_GETBMPROWBYTES(size.cx,4), GLFMT_A8R8G8B8 );

	// tpXɂ
	::GetFullPathName( lpszFileName, 256, m_szFilePath, NULL );
	
	// J[L[ݒ
	m_ColorKey = ColorKey;

	::SDIB32GL_DebugOutput( " +- LoadFromFileEx  : Adr=0x%08X, File=\"%s\";\n", this, lpszFileName );

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	DIBobt@쐬
|
|	ADIB쐬܂
|
|	[]
|
|	LONG nWidthc쐬镝
|	LONG nHeightc쐬鍂
|	SDIB32GLCOLOR FillColorcœhԂF(ftHgł͍)
|	HDC hdccDC̍쐬ΏۂłfoCXDC(ʏNULLw)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::CreateBuffer( int nWidth, int nHeight, SDIB32GLCOLOR FillColor, HDC hdc )
{
	_ASSERTE( m_pBits == NULL );
	if( m_pBits != NULL ) return SDIB32GLERR_SDIB32GLALREADYCREATED;

	// rbg}bvݒ
	BITMAPINFOHEADER bi = { NULL };
	bi.biSize        = sizeof(BITMAPINFOHEADER);
	bi.biWidth       = nWidth;
	bi.biHeight      = -nHeight;
	bi.biPlanes      = 1;
	bi.biCompression = BI_RGB;
	bi.biSizeImage   = nWidth*nHeight*4;
	bi.biBitCount    = 32;


	// DIB쐬
	// 
	// 1̃foCXReLXg͑3
	// iUsageDIB_RGB_COLORS̏ꍇ͖̂NULL
	m_hBitmap = ::CreateDIBSection( NULL, (BITMAPINFO*)&bi, DIB_RGB_COLORS, (LPVOID*)&m_pBits, NULL, 0 );

	if( m_hBitmap == NULL ) return SDIB32GLERR_DIBNOTCREATED;


	// foCXReLXg쐬
	// ̃foCXReLXgNULL̏ꍇ
	// AvP[ṼJgXN[ƌ݊
	m_hMemDC = ::CreateCompatibleDC( hdc );
	
	if( m_hMemDC == NULL )
	{
		SAFE_DELETE_OBJECT( m_hBitmap );
		m_pBits = NULL;
		return SDIB32GLERR_MEMORYDCNOTCREATED;
	}

	// DCDIB֘AÂ
	::SelectObject( m_hMemDC, m_hBitmap );


	// XLC(ANZXobt@)ݒ
	m_ppScanLine = new LPSDIB32GLCOLOR[ nHeight ];

	if( m_ppScanLine == NULL )
	{
		SAFE_DELETE_DC( m_hMemDC );
		SAFE_DELETE_OBJECT( m_hBitmap );
		m_pBits = NULL;
		return SDIB32GLERR_OUTOFMEMORY;
	}

	LPSDIB32GLCOLOR pBits  = m_pBits;
	LPSDIB32GLCOLOR* ppSL  = m_ppScanLine;

	// YW̐擪AhX
	for( int i = 0; i < nHeight; i++ )
	{
		ppSL[i] = &pBits[i*nWidth];
	}

	// f[^ݒ
	m_SorceDC	  = hdc;
	m_dwSizeImage = bi.biSizeImage;
	m_dwPixels	  = nWidth*nHeight;
	m_nWidth      = nWidth;
	m_nHeight     = nHeight;
	SetClipArea( 0, 0, m_nWidth, m_nHeight );

	// obt@w肵J[Ŗ߂
	Clear( FillColor );

	::SDIB32GL_DebugOutput( " |- CreateBuffer    : Adr=0x%08X, Width=%d, Height=%d;\n", this, m_nWidth, m_nHeight );

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	IWiSDIB32GL̃obt@𕡐
|
|	[]
|
|	LPSDIB32GL lpSDIB32GLOriginalc
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::DuplicateBuffer( LPSDIB32GL lpSDIB32GLOriginal )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSDIB32GLOriginal != NULL );
	if( lpSDIB32GLOriginal == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpOriginal = safe_cast( LPSDIB32GLBASE, lpSDIB32GLOriginal );
	INVALIDOBJECTCHECK( lpOriginal );

	_ASSERTE( m_pBits == NULL );
	_ASSERTE( lpOriginal->m_pBits != NULL );

	if( m_pBits != NULL ) return SDIB32GLERR_SDIB32GLALREADYCREATED;
	if( lpOriginal->m_pBits == NULL ) return SDIB32GLERR_SDIB32GLALREADYCREATED;

	// IWiɃobt@쐬
	HRESULT hr = CreateBuffer( lpOriginal->m_nWidth, lpOriginal->m_nHeight, SDIB32GL_XRGB(0,0,0), lpOriginal->m_SorceDC );

	if( FAILED( hr ) ) return hr;

	// f[^Rs[
	::memmove( m_pBits, lpOriginal->m_pBits, lpOriginal->m_dwSizeImage );
	::strcpy( m_szFilePath, lpOriginal->m_szFilePath ); 
	m_ColorKey = lpOriginal->m_ColorKey;
	m_rcClip = lpOriginal->m_rcClip;

	::SDIB32GL_DebugOutput( " +- DuplicateBuffer : Adr=0x%08X, Original=0x%08X;\n", this, lpOriginal );

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	t@Cɕۑ
|
|	ۑtH[}bg͊gqŔʂ܂
|	JPEG̕i85Œ(r1`100Y)ł
|
|	ΉsN`t@C: 
|	Bitmap(24)ATarga(24)AJpegAPNG(24)
|
|	[]
|	const char* lpszFileNamecރt@C
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::SaveAsFile( const char* lpszFileName )
{
	_ASSERTE( m_pBits != NULL );
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	CGraphicSaver gs;

	GSIMAGEINFO		ImgInfo;
	GSPICTUREINFO	PicInfo;

	// t@Cgq擾ăt@C^Cv
	char ext[_MAX_EXT];
	::_splitpath( lpszFileName, NULL, NULL, NULL, ext );
	::CharUpper( ext );

	if( strcmp( ext, ".BMP" ) == 0 )
	{
		PicInfo.PicType = GSPICTYPE_BMP;
		PicInfo.PicBPP	= GSPICBPP_24;
	}else if( strcmp( ext, ".JPG" ) == 0 )
	{
		PicInfo.PicType = GSPICTYPE_JPG;
		PicInfo.PicBPP	= GSPICBPP_24;
	}else if( strcmp( ext, ".JPEG" ) == 0 )
	{
		PicInfo.PicType = GSPICTYPE_JPG;
		PicInfo.PicBPP	= GSPICBPP_24;
	}else if( strcmp( ext, ".PNG" ) == 0 )
	{
		PicInfo.PicType = GSPICTYPE_PNG;
		PicInfo.PicBPP	= GSPICBPP_24;
	}else if( strcmp( ext, ".TGA" ) == 0 )
	{
		PicInfo.PicType = GSPICTYPE_TGA;
		PicInfo.PicBPP	= GSPICBPP_24;
	}else
	{
		return SDIB32GLERR_UNSUPPORTEDFILE;
	}

	ImgInfo.lpBits		= m_pBits;
	ImgInfo.dwSize		= m_dwSizeImage;
	ImgInfo.dwRowBytes	= GS_GETBMPROWBYTES( m_nWidth, 4 );
	ImgInfo.dwWidth		= m_nWidth;
	ImgInfo.dwHeight	= m_nHeight;
	ImgInfo.Format		= GSFMT_A8R8G8B8;
	ImgInfo.lpPalette	= NULL;
	ImgInfo.bTopDown	= TRUE;

	PicInfo.bJPEGProgression = FALSE;
	PicInfo.dwJPEGQuality	 = 85;

	// 
	DWORD size = gs.SavePicture( lpszFileName, &PicInfo, &ImgInfo );

	if( !size ) return SDIB32GLERR_FILENOTCREATED;

	::SDIB32GL_DebugOutput( " @ SaveAsFile   : Adr=0x%08X, File=\"%s\", Size=%dbyte;\n", this, lpszFileName, size );

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	t@Cɕۑ
|
|	ڍׂȏŕۑł܂B
|
|	ΉsN`t@C: 
|	Bitmap(24A32)ATarga(24A32)AJpegAPNG(24A32)
|
|	[]
|	const char* lpszFileNamecރt@C
|	const LPSDIB32GLSAVEPICINFO lpPicInfocۑsN`CtH\
|	LPDWORD lpdwSizec񂾃TCY󂯎obt@(NULLw)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::SaveAsFileEx( const char* lpszFileName, const LPSDIB32GLSAVEPICINFO lpPicInfo, LPDWORD lpdwSize )
{
	_ASSERTE( m_pBits != NULL );
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	CGraphicSaver gs;

	GSIMAGEINFO		ImgInfo;

	ImgInfo.lpBits		= m_pBits;
	ImgInfo.dwSize		= m_dwSizeImage;
	ImgInfo.dwRowBytes	= GS_GETBMPROWBYTES( m_nWidth, 4 );
	ImgInfo.dwWidth		= m_nWidth;
	ImgInfo.dwHeight	= m_nHeight;
	ImgInfo.Format		= GSFMT_A8R8G8B8;
	ImgInfo.lpPalette	= NULL;
	ImgInfo.bTopDown	= TRUE;

	// 
	DWORD size = gs.SavePicture( lpszFileName, (LPGSPICTUREINFO)lpPicInfo, &ImgInfo );
	
	if( lpdwSize ) *lpdwSize = size;

	if( !size ) return SDIB32GLERR_FILENOTCREATED;

	::SDIB32GL_DebugOutput( " @ SaveAsFile   : Adr=0x%08X, File=\"%s\", Size=%dbyte;\n", this, lpszFileName, size );

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	NbsÖݒ
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::SetClipRect( LPRECT lpRect )
{

	if( lpRect == NULL ) return E_POINTER;

	RECT rcRet = { 0, 0, m_nWidth, m_nHeight };

	// ̋`̈悩Ԃ
	if( !::IntersectRect( &rcRet, &rcRet, lpRect ) ) return SDIB32GLERR_INVALIDPARAMS;

	m_rcClip = rcRet;

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]̃TCYɍ킹čWTCỸNbsO
|
|	]]ɓ]鎞ɓ]̃TCYɍ悤
|	]̍WƃTCY𒲐
*----------------------------------------------------------------------------*/
STDMETHODIMP_(bool) CSDib32GLBase::Clipping( const LPSDIB32GLBASE lpSrc, SDIB32GLSTATUS& st, const LPSIZE lpDstSize, const LPPOINT lpSrcPt, const LPSIZE lpSrcSize )
{
	SIZE SrcSize;
	SIZE DstSize;

	// ~[tO
	bool bMirrorLR = false;		// EΏ	
	bool bMirrorTB = false;		// ㉺Ώ


	if( lpDstSize == NULL )
	{
		DstSize.cx = m_nWidth;
		DstSize.cy = m_nHeight;
	
	}else
	{
		// (2004/2/24) oOC
		// ETCY(|C^̒l)Ă̂C

		if( lpDstSize->cx < 0 )
		{
			// Ȃ獶E~[]
			bMirrorLR = true;
			DstSize.cx = -lpDstSize->cx;
			
		}else
		{
			DstSize.cx = lpDstSize->cx;
		}

		if( DstSize.cx == 0 )
		{
			return false;
		}

		if( lpDstSize->cy < 0 )
		{
			// Ȃ㉺~[]
			bMirrorTB  = true;
			DstSize.cy = -lpDstSize->cy;

		}else
		{
			DstSize.cy = lpDstSize->cy;
		}

		if( DstSize.cy == 0 )
		{
			return false;
		}

	}


	// TCY̎擾
	if( lpSrcSize == NULL )
	{
		// w薳ŃftHgTCY
		SrcSize.cx = lpSrc->m_nWidth;
		SrcSize.cy = lpSrc->m_nHeight;

	}else
	{

		// (2004/2/24) oOC
		// ETCY(|C^̒l)Ă̂C

		if( lpSrcSize->cx < 0 )
		{
			SrcSize.cx = -lpSrcSize->cx;
		}else
		{
			SrcSize.cx = lpSrcSize->cx;
		}

		if( SrcSize.cx > lpSrc->m_nWidth )
		{
			if( SrcSize.cx != DstSize.cx )
			{
				// ftHg̕
				SrcSize.cx = lpSrc->m_nWidth;
			}else
			{
				DstSize.cx = SrcSize.cx = lpSrc->m_nWidth;
			}

		}else if( SrcSize.cx == 0 )
		{
			return false;
		}

		if( lpSrcSize->cy < 0 )
		{
			SrcSize.cy = -lpSrcSize->cy;
		}else
		{
			SrcSize.cy = lpSrcSize->cy;
		}

		if(SrcSize.cy > lpSrc->m_nHeight )
		{
			if( SrcSize.cy != DstSize.cy )
			{
				// ftHg̍
				SrcSize.cy = lpSrc->m_nHeight;
			}else
			{
				DstSize.cy = SrcSize.cy = lpSrc->m_nHeight;
			}

		}else if( SrcSize.cy == 0 )
		{
			return false;
		}

	}


	// ]W̎擾
	if( lpSrcPt == NULL )
	{
		st.nSrcX = 0;
		st.nSrcY = 0;

	}else
	{
		st.nSrcX = lpSrcPt->x;
		st.nSrcY = lpSrcPt->y;

		// ]WG[
		_ASSERTE( st.nSrcX>=0 );
		_ASSERTE( st.nSrcY>=0 );
		_ASSERTE( st.nSrcX<lpSrc->m_nWidth && st.nSrcY<lpSrc->m_nHeight );

		if( st.nSrcX+SrcSize.cx > lpSrc->m_nWidth )
		{
			if( SrcSize.cx != DstSize.cx )
			{
				SrcSize.cx = lpSrc->m_nWidth - st.nSrcX;
			}else
			{
				DstSize.cx = SrcSize.cx = lpSrc->m_nWidth - st.nSrcX;
			}
		}

		if( st.nSrcY+SrcSize.cy > lpSrc->m_nHeight )
		{
			if( SrcSize.cy != DstSize.cy )
			{
				SrcSize.cy = lpSrc->m_nHeight - st.nSrcY;
			}else
			{
				DstSize.cy = SrcSize.cy = lpSrc->m_nHeight - st.nSrcY;
			}
		} 
	}


	// `悷TCY̐ݒ
	st.nWidth  = DstSize.cx;
	st.nHeight = DstSize.cy;


	if( (DstSize.cx == SrcSize.cx) && (DstSize.cy == SrcSize.cy) )
	{
		//if( st.nDstX >= m_rcClip.right || st.nDstY >= m_rcClip.bottom ) return false;
		if( ((m_rcClip.right-1)-st.nDstX | (m_rcClip.bottom-1)-st.nDstY) < 0 ) return false;

		st.bZoom = false;	// gk

		if( bMirrorLR )
		{
			// EΏ
			st.nSrcX = ((SrcSize.cx-1)+st.nSrcX);		// ]JnWtɂ
			st.nSrcAddDirX = -4;						// X̉Z͋t

			if( st.nDstX < m_rcClip.left )
			{
				st.nSrcX  -= m_rcClip.left - st.nDstX;			// ]W獶Nbv̈悩͂ꂽ
				st.nWidth -= m_rcClip.left - st.nDstX;			// ̃p[^͓
				st.nDstX   = m_rcClip.left;						// ̃p[^͓
				if( st.nWidth < 1 ) return false;
			}

		}else
		{
			// ftHg
			st.nSrcAddDirX = 4;							// X̉Z͒ʏ

			if( st.nDstX < m_rcClip.left )
			{
				st.nSrcX  += m_rcClip.left - st.nDstX;			// ]WɍNbv̈悩͂ꂽ𑫂
				st.nWidth -= m_rcClip.left - st.nDstX;			// 獶Nbv̈悩͂ꂽ
				st.nDstX   = m_rcClip.left;						// ]Nbv̈ɂ
				if( st.nWidth < 1 ) return false;
			}
		}

		// ENbv̈悩]Wɂ
		if( st.nDstX+st.nWidth > m_rcClip.right )
		{
			st.nWidth = m_rcClip.right - st.nDstX;
		}


		if( bMirrorTB )
		{
			// ㉺Ώ
			st.nSrcY = ((SrcSize.cy-1)+st.nSrcY);		// ]JnWtɂ

			if( st.nDstY < m_rcClip.top )
			{
				st.nSrcY   -= m_rcClip.top - st.nDstY;		// ]WNbv̈悩͂ꂽ
				st.nHeight -= m_rcClip.top - st.nDstY;		// ̃p[^͓
				st.nDstY    = m_rcClip.top;					// ̃p[^͓
				if( st.nHeight < 1 ) return false;
			}

			// ̃Ĉ߂ɉZoCg
			if( bMirrorLR )
			{
				st.nSrcAddDirY = -(lpSrc->m_nWidth-st.nWidth)<<2;	// E~[+㉺~[
			}else
			{
				st.nSrcAddDirY = -(lpSrc->m_nWidth+st.nWidth)<<2;	// EftHg+㉺~[
			}

		}else
		{
			// ftHg
			if( st.nDstY < m_rcClip.top )
			{
				st.nSrcY   += m_rcClip.top - st.nDstY;		// ]WɏNbv̈悩͂ꂽ𑫂
				st.nHeight -= m_rcClip.top - st.nDstY;		// Nbv̈悩͂ꂽ
				st.nDstY    = m_rcClip.top;					// ]Nbv̈ɂ
				if( st.nHeight < 1 ) return false;
			}

			// ̃Ĉ߂ɉZoCg
			if( bMirrorLR )
			{
				st.nSrcAddDirY = (lpSrc->m_nWidth+st.nWidth)<<2;	// E~[+㉺ftHg
			}else
			{
				st.nSrcAddDirY = (lpSrc->m_nWidth-st.nWidth)<<2;	// EftHg+㉺ftHg
			}

		}

		// Nbv̈悩]Wɂ
		if( st.nDstY+st.nHeight > m_rcClip.bottom )
		{
			st.nHeight = m_rcClip.bottom - st.nDstY;
		}

	}else
	{

		//if( st.nDstX >= m_rcClip.right || st.nDstY >= m_rcClip.bottom ) return false;
		if( ((m_rcClip.right-1)-st.nDstX | (m_rcClip.bottom-1)-st.nDstY) < 0 ) return false;


		st.bZoom = true;	// gkL

		// u[nASYŊgk
		// ASYƂ͈Č덷1ȏŃ`FbN
		// ̂ňȉ̂悤ɍœKł
		st.nMx  = SrcSize.cx;		// ̌덷
		st.nMy  = SrcSize.cy;		// č덷
		st.nERx = DstSize.cx;		// ̌덷Cl
		st.nERy = DstSize.cy;		// č덷Cl
		st.nEx  = -DstSize.cx;		// ̏덷
		st.nEy  = -DstSize.cy;		// c̏덷

		// kɂ]W̉ZlvZ
		st.nSrcAddRx = SrcSize.cx/DstSize.cx;
		st.nSrcAddRy = SrcSize.cy/DstSize.cy;

		// kZl̕ۑ
		LONG nRx = st.nSrcAddRx;
		LONG nRy = st.nSrcAddRy;

		// oCg֕ϊ
		st.nSrcAddRx = st.nSrcAddRx<<2;
		st.nSrcAddRy = st.nSrcAddRy<<2;

		if( bMirrorLR )
		{
			// EΏ
			st.nSrcX = ((SrcSize.cx-1)+st.nSrcX);		// ]JnWtɂ
			st.nSrcAddDirX = -4;						// X̉Z͋t
			st.nSrcAddRx = -st.nSrcAddRx;

			if( st.nDstX < m_rcClip.left )
			{
				// ͂ݏo덷vZ
				st.nEx += st.nMx*(m_rcClip.left-st.nDstX);

				if( st.nEx >= 0 )
				{
					// ͂ݏo]sNZvZ
					// LONG nClipSx = ((m_rcClip.left-st.nDstX)*SrcSize.cx)/lpDstSize.cx;
					LONG nClipSx = st.nEx/st.nERx+1;

					// ݂̌덷lɂȂ悤ɒ
					st.nEx   -= st.nERx*nClipSx;
					st.nSrcX -= nClipSx;				// ]W獶Nbv̈悩͂ꂽ
								
				}

				st.nWidth -= m_rcClip.left - st.nDstX;		// ̃p[^͓
				st.nDstX   = m_rcClip.left;					// ̃p[^͓
				if( st.nWidth < 1 ) return false;
			}

		}else
		{
			// ftHg
			st.nSrcAddDirX = 4;							// X̉Z͒ʏ

			if( st.nDstX < m_rcClip.left )
			{
				// ͂ݏo덷vZ
				st.nEx += st.nMx*(m_rcClip.left-st.nDstX);

				if( st.nEx >= 0 )
				{
					// ͂ݏo]sNZvZ
					// LONG nClipSx = ((clip.nX-st.nDstX)*SrcSize.cx)/lpDstSize.cx;
					LONG nClipSx = st.nEx/st.nERx+1;

					// ݂̌덷lɂȂ悤ɒ
					st.nEx   -= st.nERx*nClipSx;
					st.nSrcX += nClipSx;				// ]WɍNbv̈悩͂ꂽ𑫂
				}

				st.nWidth -= m_rcClip.left - st.nDstX;		// 獶Nbv̈悩͂ꂽ
				st.nDstX   = m_rcClip.left;					// ]Nbv̈ɂ
				if( st.nWidth < 1 ) return false;
			}
		}

		// ENbv̈悩]Wɂ
		if( st.nDstX+st.nWidth > m_rcClip.right )
		{
			st.nWidth = m_rcClip.right - st.nDstX;
		}


		if( bMirrorTB )
		{
			// ㉺Ώ
			st.nSrcY = ((SrcSize.cy-1)+st.nSrcY);		// ]JnWtɂ

			if( st.nDstY < m_rcClip.top )
			{
				// ͂ݏo덷vZ
				st.nEy += st.nMy*(m_rcClip.top-st.nDstY);

				if( st.nEy >= 0 )
				{
					// ͂ݏo]sNZvZ
					// LONG nClipSy = ((clip.nY-st.nDstY)*SrcSize.cy)/lpDstSize.cy;
					LONG nClipSy = st.nEy/st.nERy+1;

					// ݂̌덷lɂȂ悤ɒ
					st.nEy   -= st.nERy*nClipSy;
					st.nSrcY -= nClipSy;				// ]WNbv̈悩͂ꂽ
				}

				st.nHeight -= m_rcClip.top - st.nDstY;		// ̃p[^͓
				st.nDstY    = m_rcClip.top;					// ̃p[^͓
				if( st.nHeight < 1 ) return false;
			}

			// ̃Ĉ߂ɉZoCg
			st.nSrcAddDirY = -(lpSrc->m_nWidth<<2);
			st.nSrcAddRy   = -(lpSrc->m_nWidth*st.nSrcAddRy);

		}else
		{
			// ftHg
			if( st.nDstY < m_rcClip.top )
			{
				// ͂ݏo덷vZ
				st.nEy += st.nMy*(m_rcClip.top-st.nDstY);

				if( st.nEy >= 0 )
				{
					// ͂ݏo]sNZvZ
					// LONG nClipSy = ((clip.nY-st.nDstY)*SrcSize.cy)/lpDstSize.cy;
					LONG nClipSy = st.nEy/st.nERy+1;

					// ݂̌덷lɂȂ悤ɒ
					st.nEy   -= st.nERy*nClipSy;
					st.nSrcY += nClipSy;				// ]WɏNbv̈悩͂ꂽ𑫂
				}

				st.nHeight -= m_rcClip.top - st.nDstY;		// Nbv̈悩͂ꂽ
				st.nDstY    = m_rcClip.top;					// ]Nbv̈ɂ
				if( st.nHeight < 1 ) return false;
			}

			// ̃Ĉ߂ɉZoCg
			st.nSrcAddDirY = lpSrc->m_nWidth<<2;
			st.nSrcAddRy   = lpSrc->m_nWidth*st.nSrcAddRy;

		}

		// Nbv̈悩]Wɂ
		if( st.nDstY+st.nHeight > m_rcClip.bottom )
		{
			st.nHeight = m_rcClip.bottom - st.nDstY;
		}

		// kɉZ镪덷Cl
		st.nMx -= st.nERx*nRx;
		st.nMy -= st.nERy*nRy;

	}

	// ]̎̃Ĉ߂ɉZoCg
	st.nDstAddY = (m_nWidth-st.nWidth)<<2;

	return true;
}


/*----------------------------------------------------------------------------*
|	]̃TCYɍ킹čWTCỸNbsO ]o[W
|
|	]]ɓ]鎞ɓ]̃TCYɍ悤
|	]̍WƃTCY𒲐
*----------------------------------------------------------------------------*/
STDMETHODIMP_(bool) CSDib32GLBase::Clipping( const LPSDIB32GLBASE lpSrc, SDIB32GLROTATESTATUS& rst, const LPSIZE lpDstSize, const LPPOINT lpSrcPt, const LPSIZE lpSrcSize, const LPPOINT lpCenterPt )
{

	SIZE SrcSize;
	SIZE DstSize;

	// ~[tO
	bool bMirrorLR = false;		// EΏ	
	bool bMirrorTB = false;		// ㉺Ώ

	if( lpDstSize == NULL )
	{
		DstSize.cx = m_nWidth;
		DstSize.cy = m_nHeight;
	
	}else
	{
		// (2004/2/24) oOC
		// ETCY(|C^̒l)Ă̂C

		if( lpDstSize->cx < 0 )
		{
			// Ȃ獶E~[]
			bMirrorLR = true;
			DstSize.cx = -lpDstSize->cx;
			
		}else
		{
			DstSize.cx = lpDstSize->cx;
		}

		if( DstSize.cx == 0 )
		{
			return false;
		}

		if( lpDstSize->cy < 0 )
		{
			// Ȃ㉺~[]
			bMirrorTB  = true;
			DstSize.cy = -lpDstSize->cy;

		}else
		{
			DstSize.cy = lpDstSize->cy;
		}

		if( DstSize.cy == 0 )
		{
			return false;
		}
	}


	// TCY̎擾
	if( lpSrcSize == NULL )
	{
		// w薳ŃftHgTCY
		SrcSize.cx = lpSrc->m_nWidth;
		SrcSize.cy = lpSrc->m_nHeight;

	}else
	{

		// (2004/2/24) oOC
		// ETCY(|C^̒l)Ă̂C

		if( lpSrcSize->cx < 0 )
		{
			SrcSize.cx = -lpSrcSize->cx;
		}else
		{
			SrcSize.cx = lpSrcSize->cx;
		}

		if( SrcSize.cx > lpSrc->m_nWidth )
		{
			if( SrcSize.cx != DstSize.cx )
			{
				// ftHg̕
				SrcSize.cx = lpSrc->m_nWidth;
			}else
			{
				DstSize.cx = SrcSize.cx = lpSrc->m_nWidth;
			}

		}else if( SrcSize.cx == 0 )
		{
			return false;
		}

		if( lpSrcSize->cy < 0 )
		{
			SrcSize.cy = -lpSrcSize->cy;
		}else
		{
			SrcSize.cy = lpSrcSize->cy;
		}

		if( SrcSize.cy > lpSrc->m_nHeight )
		{
			if( SrcSize.cy != DstSize.cy )
			{
				// ftHg̍
				SrcSize.cy = lpSrc->m_nHeight;
			}else
			{
				DstSize.cy = SrcSize.cy = lpSrc->m_nHeight;
			}

		}else if( SrcSize.cy == 0 )
		{
			return false;
		}
	}


	// ]W̎擾
	if( lpSrcPt == NULL )
	{
		rst.nSrcX = 0;
		rst.nSrcY = 0;

	}else
	{
		rst.nSrcX = lpSrcPt->x;
		rst.nSrcY = lpSrcPt->y;

		// ]WG[
		_ASSERTE( rst.nSrcX>=0 );
		_ASSERTE( rst.nSrcY>=0 );
		_ASSERTE( rst.nSrcX<lpSrc->m_nWidth && rst.nSrcY<lpSrc->m_nHeight );

		if( rst.nSrcX+SrcSize.cx > lpSrc->m_nWidth )
		{
			if( SrcSize.cx != DstSize.cx )
			{
				SrcSize.cx = lpSrc->m_nWidth - rst.nSrcX;
			}else
			{
				DstSize.cx = SrcSize.cx = lpSrc->m_nWidth - rst.nSrcX;
			}
		}

		if( rst.nSrcY+SrcSize.cy > lpSrc->m_nHeight )
		{
			if( SrcSize.cy != DstSize.cy )
			{
				SrcSize.cy = lpSrc->m_nHeight - rst.nSrcY;
			}else
			{
				DstSize.cy = SrcSize.cy = lpSrc->m_nHeight - rst.nSrcY;
			}
		} 
	}

	// TCRTCl擾
	SDIB32GLFIXED fxCos = CSinCosTable::Cos( rst.nAngle );
	SDIB32GLFIXED fxSin = CSinCosTable::Sin( rst.nAngle );

	// `悷TCY̌vZ(ľܓ)
	rst.nWidth  = (::abs(fxCos*DstSize.cx)+::abs(fxSin*DstSize.cy)+0x10000)>>16;
	rst.nHeight = (::abs(fxSin*DstSize.cx)+::abs(fxCos*DstSize.cy)+0x10000)>>16;

	// 1/2TCY
	LONG nWidthDiv2  = rst.nWidth>>1;
	LONG nHeightDiv2 = rst.nHeight>>1;

	if( lpCenterPt == NULL )
	{
		// ݂̃|WV𒆐Sɉ]
		rst.nDstX = (rst.nDstX+(DstSize.cx>>1))-nWidthDiv2;
		rst.nDstY = (rst.nDstY+(DstSize.cy>>1))-nHeightDiv2;

	}else
	{
		// Cӂ̃|WV𒆐Sɉ]
		LONG nRx = (rst.nDstX+(DstSize.cx>>1))-lpCenterPt->x;
		LONG nRy = (rst.nDstY+(DstSize.cy>>1))-lpCenterPt->y;
		rst.nDstX = ((fxCos*nRx+fxSin*nRy)>>16)+lpCenterPt->x-nWidthDiv2;
		rst.nDstY = ((fxCos*nRy-fxSin*nRx)>>16)+lpCenterPt->y-nHeightDiv2;
	}

	// NbsOł͂ݏö
	LONG nClipSx = 0;
	LONG nClipSy = 0;

	// ]悪`Ώۗ̈悩͂ꂽꍇ
	if( rst.nDstX >= m_rcClip.right || rst.nDstY >= m_rcClip.bottom ) return false;

	// Wx̃Nbv
	if( rst.nDstX < m_rcClip.left )
	{ 
		nClipSx     = m_rcClip.left-rst.nDstX;
		rst.nWidth -= nClipSx;
		rst.nDstX   = m_rcClip.left;
		if( rst.nWidth < 1 ) return false;
	}

	// WỹNbv
	if( rst.nDstY < m_rcClip.top )
	{
		nClipSy      = m_rcClip.top-rst.nDstY;
		rst.nHeight -= nClipSy;
		rst.nDstY    = m_rcClip.top;
		if( rst.nHeight < 1 ) return false;
	}

	// EWx̃Nbv
	if( rst.nDstX+rst.nWidth > m_rcClip.right )
	{
		rst.nWidth = m_rcClip.right-rst.nDstX;
	}
	
	// EWỹNbv
	if( rst.nDstY+rst.nHeight > m_rcClip.bottom )
	{
		rst.nHeight = m_rcClip.bottom-rst.nDstY;
	}

	// _S̉]̓]JnW߂
	LONG nRx = nClipSx-nWidthDiv2;
	LONG nRy = nClipSy-nHeightDiv2;
	rst.fxSrcScanX = fxCos*nRx-fxSin*nRy;
	rst.fxSrcScanY = fxSin*nRx+fxCos*nRy;

	if( (DstSize.cx == SrcSize.cx) && (DstSize.cy == SrcSize.cy) )
	{
		// gkȂ̂64rbgȂ
		rst.b64bit = false;
		
		// XYZ
		rst.fxSrcAddXx  =  fxCos;
		rst.fxSrcAddXy  =  fxSin;
		rst.fxSrcAddYx  = -fxSin;
		rst.fxSrcAddYy  =  fxCos;
		rst.fxSrcAddYx -=  rst.fxSrcAddXx*rst.nWidth;
		rst.fxSrcAddYy -=  rst.fxSrcAddXy*rst.nWidth;

		if( bMirrorLR )
		{
			// EΏ
			rst.fxSrcAddXx = -rst.fxSrcAddXx;
			rst.fxSrcAddYx = -rst.fxSrcAddYx;
			rst.fxSrcScanX = -rst.fxSrcScanX;
		}
		
		if( bMirrorTB )
		{
			// ㉺Ώ
			rst.fxSrcAddXy = -rst.fxSrcAddXy;
			rst.fxSrcAddYy = -rst.fxSrcAddYy;
			rst.fxSrcScanY = -rst.fxSrcScanY;
		}

		// ]NbsÖ
		rst.fxSrcLeft   = rst.nSrcX<<16;
		rst.fxSrcTop    = rst.nSrcY<<16;
		rst.fxSrcRight  = rst.fxSrcLeft+(SrcSize.cx<<16);
		rst.fxSrcBottom = rst.fxSrcTop+(SrcSize.cy<<16);

		// ]JnW߂
		rst.fxSrcScanX += rst.fxSrcLeft+(SrcSize.cx<<15);	// (SrcSize.cx<<16)/2
		rst.fxSrcScanY += rst.fxSrcTop+(SrcSize.cy<<15);

	}else
	{
		// vZʂ64rbgl
		LONG nWidthAddX_H;
		LONG nWidthAddX_L;
		LONG nWidthAddY_H;
		LONG nWidthAddY_L;
		LONG nOverFlow = 0;	// I[o[t[tO


		// XYZ
		rst.fxSrcAddXx  =  fxCos*SrcSize.cx/DstSize.cx;
		rst.fxSrcAddXy  =  fxSin*SrcSize.cy/DstSize.cy;
		rst.fxSrcAddYx  = -fxSin*SrcSize.cx/DstSize.cx;
		rst.fxSrcAddYy  =  fxCos*SrcSize.cy/DstSize.cy;

		// OMulDiv̂64rbg
		__asm
		{
			// JnXW̌vZ ::MulDiv(rst.fxSrcScanX,SrcSize.cx,DstSize.cx)
			mov edi, rst

			mov eax, [edi]rst.fxSrcScanX
			mov ecx, SrcSize.cx

			cmp eax, 0				// ̐ǂ
			jge L1_X

			neg eax					// ̐ɂ

		L1_X:
			mul ecx					// rst.fxSrcScanX * SrcSize.cx  :edx : eax

			mov ebx, eax			// ʌʂۑ
			mov eax, edx			// ʌʂZpeaxWX^ɓ]
			
			mov edx, 0				// ʃWX^͎gpȂ
			mov ecx, DstSize.cx	

			div ecx					// Zʌ/DstSize.cx

			mov esi, eax			// ʂۑ(Z)
			mov eax, ebx			// ZʌʂZpeaxWX^ɓ]

			div ecx					// Zʂ̗]ƏZʌ/DstSize.cx
			
			cmp esi, 0				// I[o[t[ǂ
			je NOT_CF_X

			inc nOverFlow			// I[o[t[

	NOT_CF_X:
			cmp [edi]rst.fxSrcScanX, 0				// ̐ǂ
			jge L2_X

			neg eax					// ̐ɂ(̎eax!=0Ȃ CF=1)

			adc esi, 0				// CF̒lZ
			
			neg esi					// ̐ɂ

		L2_X:

			mov [edi]rst.fxSrcScanX_H, esi		// ʌʂ]
			mov [edi]rst.fxSrcScanX_L, eax		// ʌʂ]


			// JnYW̌vZ ::MulDiv(rst.fxSrcScanY,SrcSize.cy,DstSize.cy)
			mov eax, [edi]rst.fxSrcScanY
			mov ecx, SrcSize.cy

			cmp eax, 0				// ̐ǂ
			jge L1_Y

			neg eax					// ̐ɂ

		L1_Y:
			mul ecx					// rst.fxSrcScanY * SrcSize.cy  :edx : eax

			mov ebx, eax			// ʌʂۑ
			mov eax, edx			// ʌʂZpeaxWX^ɓ]
			
			mov edx, 0				// ʃWX^͎gpȂ
			mov ecx, DstSize.cy	

			div ecx					// Zʌ/DstSize.cy

			mov esi, eax			// ʂۑ(Z)
			mov eax, ebx			// ZʌʂZpeaxWX^ɓ]

			div ecx					// Zʂ̗]ƏZʌ/DstSize.cy

			cmp esi, 0				// I[o[t[ǂ
			je NOT_CF_Y

			inc nOverFlow			// I[o[t[

	NOT_CF_Y:
			cmp [edi]rst.fxSrcScanY, 0		// ̐ǂ
			jge L2_Y

			neg eax					// ̐ɂ(̎eax!=0Ȃ CF=1)

			adc esi, 0				// CF̒lZ
			
			neg esi					// ̐ɂ

		L2_Y:

			mov [edi]rst.fxSrcScanY_H, esi		// ʌʂ]
			mov [edi]rst.fxSrcScanY_L, eax		// ʌʂ]


			// YCւ̎̉ZlxvZ( rst.fxSrcAddXx*rst.nWidth )
			mov eax, [edi]rst.fxSrcAddXx
			
			imul [edi]rst.nWidth

			mov nWidthAddX_H, edx		// 32rbg
			mov nWidthAddX_L, eax		// 32rbg

			adc nOverFlow, 0
			// YCւ̎̉ZlyvZ( rst.fxSrcAddXy*rst.nWidth )
			mov eax, [edi]rst.fxSrcAddXy
			
			imul [edi]rst.nWidth

			mov nWidthAddY_H, edx		// 32rbg
			mov nWidthAddY_L, eax		// 32rbg

			adc nOverFlow, 0

			// I[o[t[`FbN
			mov eax, [edi]rst.fxSrcAddYx
			
			imul [edi]rst.nHeight
			
			adc nOverFlow, 0
			mov eax, [edi]rst.fxSrcAddYy
			
			imul [edi]rst.nHeight

			adc nOverFlow, 0
		}

	//	nOverFlow=1;	// fobOp

		if( !nOverFlow )
		{
			// I[o[t[Ȃ̂64rbgȂ
			rst.b64bit = false;
			
			rst.fxSrcAddYx -=  nWidthAddX_L;
			rst.fxSrcAddYy -=  nWidthAddY_L;

			if( bMirrorLR )
			{
				// EΏ
				rst.fxSrcAddXx = -rst.fxSrcAddXx;
				rst.fxSrcAddYx = -rst.fxSrcAddYx;
				rst.fxSrcScanX = -rst.fxSrcScanX;
			}
			
			if( bMirrorTB )
			{
				// ㉺Ώ
				rst.fxSrcAddXy = -rst.fxSrcAddXy;
				rst.fxSrcAddYy = -rst.fxSrcAddYy;
				rst.fxSrcScanY = -rst.fxSrcScanY;
			}

			// ]NbsÖ
			rst.fxSrcLeft   = rst.nSrcX<<16;
			rst.fxSrcTop    = rst.nSrcY<<16;
			rst.fxSrcRight  = rst.fxSrcLeft+(SrcSize.cx<<16);
			rst.fxSrcBottom = rst.fxSrcTop+(SrcSize.cy<<16);

			// ]JnW߂
			rst.fxSrcScanX += rst.fxSrcLeft+(SrcSize.cx<<15);	// (SrcSize.cx<<16)/2
			rst.fxSrcScanY += rst.fxSrcTop+(SrcSize.cy<<15);

		}else
		{
			// I[o[t[L
			rst.b64bit = true;

			// 32rbg64rbgɃLXg
			__asm mov edi, rst
			SDIB32GL_INT32ToINT64( [edi]rst.fxSrcAddXx_H, [edi]rst.fxSrcAddXx_L, [edi]rst.fxSrcAddXx );
			SDIB32GL_INT32ToINT64( [edi]rst.fxSrcAddXy_H, [edi]rst.fxSrcAddXy_L, [edi]rst.fxSrcAddXy );
			SDIB32GL_INT32ToINT64( [edi]rst.fxSrcAddYx_H, [edi]rst.fxSrcAddYx_L, [edi]rst.fxSrcAddYx );
			SDIB32GL_INT32ToINT64( [edi]rst.fxSrcAddYy_H, [edi]rst.fxSrcAddYy_L, [edi]rst.fxSrcAddYy );

			SDIB32GL_SUB64( [edi]rst.fxSrcAddYx_H, [edi]rst.fxSrcAddYx_L,
				[edi]rst.fxSrcAddYx_H, [edi]rst.fxSrcAddYx_L, nWidthAddX_H, nWidthAddX_L );

			SDIB32GL_SUB64( [edi]rst.fxSrcAddYy_H, [edi]rst.fxSrcAddYy_L,
				[edi]rst.fxSrcAddYy_H, [edi]rst.fxSrcAddYy_L, nWidthAddY_H, nWidthAddY_L );

			if( bMirrorLR )
			{
				// EΏ
				__asm mov edi, rst
				SDIB32GL_NEG64( [edi]rst.fxSrcAddXx_H, [edi]rst.fxSrcAddXx_L );
				SDIB32GL_NEG64( [edi]rst.fxSrcAddYx_H, [edi]rst.fxSrcAddYx_L );
				SDIB32GL_NEG64( [edi]rst.fxSrcScanX_H, [edi]rst.fxSrcScanX_L );
			}
			
			if( bMirrorTB )
			{
				// ㉺Ώ
				__asm mov edi, rst
				SDIB32GL_NEG64( [edi]rst.fxSrcAddXy_H, [edi]rst.fxSrcAddXy_L );
				SDIB32GL_NEG64( [edi]rst.fxSrcAddYy_H, [edi]rst.fxSrcAddYy_L );
				SDIB32GL_NEG64( [edi]rst.fxSrcScanY_H, [edi]rst.fxSrcScanY_L );
			}

			// ]NbsÖ
			rst.nSrcLeft   = rst.nSrcX;
			rst.nSrcTop    = rst.nSrcY;
			rst.nSrcRight  = rst.nSrcX+SrcSize.cx;
			rst.nSrcBottom = rst.nSrcY+SrcSize.cy;

			// ]JnW߂
			SDIB32GLFIXED fxAddScanX = (rst.nSrcX<<16)+(SrcSize.cx<<15);	// (SrcSize.cx<<16)/2
			SDIB32GLFIXED fxAddScanY = (rst.nSrcY<<16)+(SrcSize.cy<<15);

			__asm mov edi, rst
			SDIB32GL_ADD64( [edi]rst.fxSrcScanX_H, [edi]rst.fxSrcScanX_L,
				[edi]rst.fxSrcScanX_H, [edi]rst.fxSrcScanX_L, 0, fxAddScanX );
			
			SDIB32GL_ADD64( [edi]rst.fxSrcScanY_H, [edi]rst.fxSrcScanY_L,
				[edi]rst.fxSrcScanY_H, [edi]rst.fxSrcScanY_L, 0, fxAddScanY );

			// Ə32rbgPʂŕ
			SDIB32GL_DIVIDEFIXED64( [edi]rst.fxSrcScanX_H, [edi]rst.fxSrcScanX_L );
			SDIB32GL_DIVIDEFIXED64( [edi]rst.fxSrcScanY_H, [edi]rst.fxSrcScanY_L );
			SDIB32GL_DIVIDEFIXED64( [edi]rst.fxSrcAddXx_H, [edi]rst.fxSrcAddXx_L );
			SDIB32GL_DIVIDEFIXED64( [edi]rst.fxSrcAddXy_H, [edi]rst.fxSrcAddXy_L );
			SDIB32GL_DIVIDEFIXED64( [edi]rst.fxSrcAddYx_H, [edi]rst.fxSrcAddYx_L );
			SDIB32GL_DIVIDEFIXED64( [edi]rst.fxSrcAddYy_H, [edi]rst.fxSrcAddYy_L );
		}
	}

	// ]̎̃Ĉ߂ɉZoCg
	rst.nDstAddY = (m_nWidth-rst.nWidth)<<2;

	return true;
}


/*----------------------------------------------------------------------------*
|	`NbsO
*----------------------------------------------------------------------------*/
STDMETHODIMP_(bool) CSDib32GLBase::Clipping( int& nX, int& nY, int& nW, int& nH )
{
	if( nW < 0 )
	{
		nW=-nW;

	}else if( nW == 0 )
	{
		return false;
	}

	if( nH < 0 )
	{ 
		nH=-nH;

	}else if( nH == 0 )
	{
		return false;
	}

	if( nX >= m_rcClip.right || nY >= m_rcClip.bottom ) return false;

	if( nX < m_rcClip.left )
	{ 
		nW -= m_rcClip.left - nX;
		nX  = m_rcClip.left;
		if( nW < 1 ) return false;
	}

	if( nY < m_rcClip.top )
	{
		nH -= m_rcClip.top - nY;
		nY  = m_rcClip.top;
		if( nH < 1 ) return false;
	}
	
	if( nX + nW > m_rcClip.right )
	{
		nW = m_rcClip.right - nX;
	}
	
	if( nY + nH > m_rcClip.bottom )
	{
		nH = m_rcClip.bottom - nY;
	}

	return true;
}


/*----------------------------------------------------------------------------*
|	gWVe[u
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::InitUniversalTransTable( DWORD* lpTransTbl, WORD wPhase, BYTE Vague )
{
	DWORD dwVague = CONVERT_255To256(Vague!=0?Vague:1);
	DWORD dwPhase = wPhase+(wPhase>>15);
	
	int e;
	dwPhase = ((dwPhase*(256+dwVague))>>16);

	for( int i = 0; i < 256; i++)
	{
		e = dwPhase-CONVERT_255To256(i);

		if( e <= 0 )
		{
			lpTransTbl[i] = 256;
		}else if( e >= dwVague )
		{
			lpTransTbl[i] = 0;
		}else
		{
			lpTransTbl[i] = 256-e*256/dwVague;
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	[Xe[^X
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::InitRuleStatus( SDIB32GLRULESTATUS& rulest, SDIB32GLSTATUS& st, DWORD dwRuleFlags )
{

	// EΏ
	if( dwRuleFlags & SDIB32GL_RULEMIRRORLEFTRIGHT )
	{
		rulest.nX = (st.nWidth-1)+st.nDstX;
		rulest.nAddDirX = -4;

	}else
	{
		rulest.nX = st.nDstX;
		rulest.nAddDirX = 4;
	}

	// ㉺Ώ
	if( dwRuleFlags & SDIB32GL_RULEMIRRORUPDOWN )
	{
		rulest.nY = (st.nHeight-1)+st.nDstY;

		if( dwRuleFlags & SDIB32GL_RULEMIRRORLEFTRIGHT )
		{
			rulest.nAddDirY = -(m_nWidth-st.nWidth)*4;
		}else
		{
			rulest.nAddDirY = -(m_nWidth+st.nWidth)*4;
		}
	}else
	{
		rulest.nY = st.nDstY;

		if( dwRuleFlags & SDIB32GL_RULEMIRRORLEFTRIGHT )
		{
			rulest.nAddDirY = (m_nWidth+st.nWidth)*4;
		}else
		{
			rulest.nAddDirY = (m_nWidth-st.nWidth)*4;
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	mNe[u
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::InitMonoTable( void )
{
	for(int i=0;i<32;i++)
	{
		for(int j=0;j<8;j++)
		{
			int k=(i*8)+j;
			m_MonoTbl[k] = SDIB32GL_ARGB(0,k,k,k);
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	W]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Blt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];


	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

			mov ebx, Status.nSrcAddDirY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]sNZf[^擾
			add esi, edx					// ~[]XZς

			mov [edi], eax					// ]sNZf[^ɓ]
			sub ecx, __DEC_WIDTH

			lea edi, [edi+4]				// ]͒ʏ
			jns loop_x0

			add esi, ebx					// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			mov edx, [esi]					// sNZf[^擾
			add esi, Status.nSrcAddRx		// k̓]XZ

			mov [edi], edx					// ]ɓ]
			add eax, Status.nMx				// X̌덷Z

			lea edi, [edi+4]				// ]WXɐi߂
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ߓ]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::ColorKeyBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

			mov ebx, ColorKey				// J[L[

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
			
			cmp [esi], ebx
			je skip_draw0

			mov eax, [esi]					// (np) ]sNZf[^擾

			mov [edi], eax					// (np) ]sNZf[^ɓ]

		skip_draw0:

			add esi, edx					// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			mov edx, [esi]					// sNZf[^擾

			cmp edx, ColorKey
			je skip_draw1

			mov [edi], edx					// ]ɓ]

		skip_draw1:

			add esi, Status.nSrcAddRx		// k̓]XZ
			add edi, 4						// ]WXɐi߂

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

		}

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::RotateBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nDstAddY

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy
			
			mov edi, pDstBits				// ]AhX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			mov [edi], esi					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)

			mov esi, ppSrcScanLine			// (np) ]AhX

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov [edi], esi					// (np) ]sNZf[^ɓ]

			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ߓ]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::RotateColorKeyBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, ColorKey

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy
			
			mov edi, pDstBits				// ]AhX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			cmp esi, edx
			je skip_draw0_colkey

			mov [edi], esi					// ]sNZf[^ɓ]

	skip_draw0_colkey:

			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)

			mov esi, ppSrcScanLine			// (np) ]AhX

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			cmp esi, ColorKey
			je skip_draw1_colkey

			mov [edi], esi					// (np) ]sNZf[^ɓ]

	skip_draw1_colkey:

			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	J[L[`lɕϊ
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::ColorKeyToAlpha( void )
{

	_ASSERTE( m_pBits != NULL);

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	__asm
	{
		mov esi, this

		mov ecx, [esi]this.m_dwPixels

		mov ebx, [esi]this.m_ColorKey
		mov edi, [esi]this.m_pBits

	loop_:
		mov edx, [edi]			// sNZf[^擾
		add edi, 4				// AhXZ

		cmp ebx, edx			// J[L[Ȃ烿`l0Ŗ߂
		je alpha_

		or edx, __Axxx_MASK		// `l255ɂ

		mov [edi-4], edx		// ]
		jmp next_

	alpha_:
		
		and edx, __xRGB_MASK		// `l0ɂ

		mov [edi-4], edx		// ]

	next_:
		dec ecx
		jne loop_
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	3F`lƂē]]֐
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::RGBToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{

	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]sNZf[^擾
			add esi, Status.nSrcAddDirX		// ~[]XZς

			xor ebx, ebx					// WX^l폜
			add edi, 4						// ]͒ʏ
			
			xor edx, edx					// WX^l폜
			mov bl, al						// vf擾
			
			shr eax, 8						// (np) ΗvfŉʃoCgɂ
			
			mov dl, al						// (np) Ηvf擾

			shr eax, 8						// ԗvfŉʃoCgɂ
			add ebx, edx					// +

			mov dl, al						// (np) ԗvf擾

			add ebx, edx					// = +(+)
			mov eax, [edi-4]

			imul ebx, 0x5555				// (R+B+G)*0.333333333333333

			add ebx, 0x1999					// 덷C (+0.1)@(R+G+B)/3Ɠľ
			and eax, __xRGB_MASK			// ]惿`l폜

			shl ebx, 8						// `lɂĂ

			and ebx, __Axxx_MASK				// `lȉ̃S~폜
			
			or eax, ebx						// `l+RGB
			sub ecx, __DEC_WIDTH			// ]

			mov [edi-4], eax				// ]sNZf[^ɓ]
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov eax, [esi]					// ]sNZf[^擾
			add esi, Status.nSrcAddRx		// k̓]XZ

			xor ebx, ebx					// WX^l폜
			add edi, 4						// ]͒ʏ
			
			xor edx, edx					// WX^l폜
			mov bl, al						// vf擾
			
			shr eax, 8						// (np) ΗvfŉʃoCgɂ
			
			mov dl, al						// (np) Ηvf擾

			shr eax, 8						// ԗvfŉʃoCgɂ
			add ebx, edx					// +

			mov dl, al						// (np) ԗvf擾

			add ebx, edx					// = +(+)
			mov eax, [edi-4]

			imul ebx, 0x5555				// (R+B+G)*0.333333333333333

			add ebx, 0x1999					// 덷C (+0.1)
			and eax, __xRGB_MASK				// ]惿`l폜

			shl ebx, 8						// `lɂĂ

			and ebx, __Axxx_MASK				// `lȉ̃S~폜

			or eax, ebx						// `l+RGB
			pop ebx

			mov [edi-4], eax				// ]sNZf[^ɓ]
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ԗvf`lƂē]]֐
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::RToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]sNZf[^擾
			add esi, edx					// ~[]XZς

			shl eax, 8						// RɂĂ
			mov ebx, [edi]					// ]sNZf[^擾

			and eax, __Axxx_MASK			// ӊÕS~폜
			and ebx, __xRGB_MASK			// `l폜
			
			or eax, ebx						// (np) `l+RGB

			mov [edi], eax					// ]sNZf[^ɓ]
			sub ecx, __DEC_WIDTH

			lea edi, [edi+4]				// ]͒ʏ
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push ebx

			mov edx, [esi]					// ]sNZf[^擾
			add esi, Status.nSrcAddRx		// k̓]XZ

			shl edx, 8						// RɂĂ
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __Axxx_MASK			// ӊÕS~폜
			and ebx, __xRGB_MASK			// `l폜
			
			or edx, ebx						// (np) `l+RGB
			pop ebx

			mov [edi], edx					// ]sNZf[^ɓ]
			add eax, Status.nMx				// X̌덷Z

			lea edi, [edi+4]				// ]͒ʏ
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Ηvf`lƂē]]֐
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::GToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]sNZf[^擾
			add esi, edx					// ~[]XZς

			shl eax, 16						// GɂĂ
			mov ebx, [edi]					// ]sNZf[^擾

			and eax, __Axxx_MASK			// ӊÕS~폜
			and ebx, __xRGB_MASK			// `l폜
			
			or eax, ebx						// (np) `l+RGB

			mov [edi], eax					// ]sNZf[^ɓ]
			sub ecx, __DEC_WIDTH

			lea edi, [edi+4]				// ]͒ʏ
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push ebx

			mov edx, [esi]					// ]sNZf[^擾
			add esi, Status.nSrcAddRx		// k̓]XZ

			shl edx, 16						// GɂĂ
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __Axxx_MASK			// ӊÕS~폜
			and ebx, __xRGB_MASK			// `l폜
			
			or edx, ebx						// (np) `l+RGB
			pop ebx

			mov [edi], edx					// ]sNZf[^ɓ]
			add eax, Status.nMx				// X̌덷Z

			lea edi, [edi+4]				// ]͒ʏ
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	vf`lƂē]]֐
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::BToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]sNZf[^擾
			add esi, edx					// ~[]XZς

			shl eax, 24						// BɂĂ
			mov ebx, [edi]					// ]sNZf[^擾

			and eax, __Axxx_MASK			// ӊÕS~폜
			and ebx, __xRGB_MASK			// `l폜
			
			or eax, ebx						// (np) `l+RGB

			mov [edi], eax					// ]sNZf[^ɓ]
			sub ecx, __DEC_WIDTH

			lea edi, [edi+4]				// ]͒ʏ
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push ebx

			mov edx, [esi]					// ]sNZf[^擾
			add esi, Status.nSrcAddRx		// k̓]XZ

			shl edx, 24						// BɂĂ
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __Axxx_MASK			// ӊÕS~폜
			and ebx, __xRGB_MASK			// `l폜
			
			or edx, ebx						// (np) `l+RGB
			pop ebx

			mov [edi], edx					// ]sNZf[^ɓ]
			add eax, Status.nMx				// X̌덷Z

			lea edi, [edi+4]				// ]͒ʏ
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l]]֐
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::AlphaToAlphaBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]sNZf[^擾
			add esi, edx					// ~[]XZς

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __Axxx_MASK			// ӊÕS~폜

			and ebx, __xRGB_MASK			// (np) `l폜
			
			or eax, ebx						// (np) `l+RGB

			mov [edi], eax					// ]sNZf[^ɓ]
			sub ecx, __DEC_WIDTH

			lea edi, [edi+4]				// ]͒ʏ
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push ebx

			mov edx, [esi]					// ]sNZf[^擾
			add esi, Status.nSrcAddRx		// k̓]XZ

			mov ebx, [edi]					// ]sNZf[^擾
			and edx, __Axxx_MASK			// ӊÕS~폜

			and ebx, __xRGB_MASK			// (np) `l폜
			
			or edx, ebx						// (np) `l+RGB
			pop ebx

			mov [edi], edx					// ]sNZf[^ɓ]
			add eax, Status.nMx				// X̌덷Z

			lea edi, [edi+4]				// ]͒ʏ
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	J[L[Cӂ̐Fœ]]֐
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::ColorKeyToColorBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	LPSDIB32GLBASE lpSrc = safe_cast( LPSDIB32GLBASE, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, ColorKey

			mov ebx, Color					// `悷F

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			cmp edx, [esi]
			jne skip_draw0

			mov [edi], ebx					// ]sNZf[^ɓ]

		skip_draw0:

			add esi, Status.nSrcAddDirX		// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			mov edx, [esi]					// sNZf[^擾

			cmp edx, ColorKey
			jne skip_draw1
			
			mov edx, Color					// `悷F

			mov [edi], edx					// ]ɓ]

		skip_draw1:

			add esi, Status.nSrcAddRx		// k̓]XZ
			add edi, 4						// ]WXɐi߂

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	WɐFݒ
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::SetPixel( int x, int y, SDIB32GLCOLOR Color )
{
	if( m_ppScanLine == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( x-m_rcClip.left < 0 || y-m_rcClip.top < 0 || x >= m_rcClip.right || y >= m_rcClip.bottom ) return SDIB32GLERR_INVALIDPOSITION;
	//if( ((x-m_rcClip.left) | (y-m_rcClip.top) | (m_rcClip.right-1)-x  | (m_rcClip.bottom-1)-y) < 0 ) return SDIB32GLERR_INVALIDPOSITION;
	
	m_ppScanLine[y][x] = Color;

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	WsNZARGBl擾
*----------------------------------------------------------------------------*/
STDMETHODIMP_(SDIB32GLCOLOR) CSDib32GLBase::GetPixel( int x, int y )
{
	if( m_ppScanLine == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( x-m_rcClip.left < 0 || y-m_rcClip.top < 0 || x >= m_rcClip.right || y >= m_rcClip.bottom ) return SDIB32GLERR_INVALIDPOSITION;
	//if( ((x-m_rcClip.left) | (y-m_rcClip.top) | (m_rcClip.right-1)-x  | (m_rcClip.bottom-1)-y) < 0 ) return SDIB32GLERR_INVALIDPOSITION;

	return m_ppScanLine[y][x];

}


/*----------------------------------------------------------------------------*
|	SẴsNZw肵FœhԂ
|
|	w肵FőSẴsNZhԂ܂
|
|	[]
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)	
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Clear( SDIB32GLCOLOR Color )
{
	_ASSERTE( m_pBits != NULL );
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	__asm
	{
		mov esi, this
		mov eax, Color					// hԂJ[

		mov edi, [esi]this.m_pBits		// EDIWX^ɃsNZAhXn
		mov ecx, [esi]this.m_dwPixels	// hԂsNZ
		
		rep stosd						// f[^]
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	w̋`̈hԂ
|
|	w肵Fŋ`̈hԂ܂
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Rectangle( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	__asm
	{
		mov edi, pBits			// ݂X,Yobt@AhX
		mov esi, dwAddWidth

		mov ecx, nWidth			// X[vJE^
		mov edx, nHeight		// Y[vJE^

		shr ecx, 1				// 2sNZÂ̂ŉE1VtgCFω <u>
		mov eax, ecx			// X[vJE^̒lۑ							<v>

		mov ebx, Color
		jnc even_loop_x			// CF1łȂȂ̃[v

	uneven_loop_y:

		// ̒[sNZ
		mov [edi], ebx			// (np)
		
		add edi, 4				// ]ׂ̃sNZɈړ
		cmp ecx, 0

		je end_uneven_loop_x	// (np)

	uneven_loop_x:

		// 2sNZ
		mov [edi+0], ebx		// `1
		mov [edi+4], ebx		// `2

		add edi, 8				// ]ׂ̃sNZɈړ
		dec ecx
		
		jne uneven_loop_x		// (np) if( ecx != 0 )

	end_uneven_loop_x:

		add edi, esi			// ̃CɈړ
		mov ecx, eax			// JE^A

		dec edx
		jne uneven_loop_y		// (np) if( edx != 0 )

		jmp end_


	even_loop_x:

		// 2sNZ
		mov [edi+0], ebx		// `1
		mov [edi+4], ebx		// `2

		add edi, 8				// ]ׂ̃sNZɈړ
		dec ecx
		
		jne even_loop_x			// (np) if( ecx != 0 )

		add edi, esi			// ̃CɈړ
		mov ecx, eax			// JE^A

		dec edx
		jne even_loop_x			// (np) if( edx != 0 )

	end_:
		
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Line( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;

	__asm
	{
		mov edi, dwDx
		mov esi, dwDy

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np)

		mov dwEnd, eax			// dwEnd = x1 + dwAx
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
	
		mov ecx, ppScanLine

		// `
		mov edi, Color			// J[
		mov esi, [ecx+ebx*4]	// YW̐擪AhX *(ppScanLine+y)

		mov [esi+eax*4], edi	// (np) ]sNZɕ` *(ppScanLine[y]+x) = Color

	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0

		jmp end_loop			// (np) I

	jump_y:

		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// dwEnd = y1 + dwAy
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

 	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1

		mov ecx, ppScanLine

		// `
		mov edi, Color			// J[
		mov esi, [ecx+ebx*4]	// YW̐擪AhX *(ppScanLine+y)

		mov [esi+eax*4], edi	// ]sNZɕ` *(ppScanLine[y]+x) = Color

	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ȉ~
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Ellipse( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;


	__asm
	{
		mov ecx, rx
		mov edx, ry

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		neg ecx					// (np) -(r*ry)

		mov edx, ecx			// (np) Rs[

		shl ecx, 1				//				<u>
		mov eax, rx				// JnXW(x)	<v>

		shl edx, 2				//				<u>
		mov ebx, 0				// JnYW(y)	<v>

		add ecx, dw2h
		add edx, dw2w

		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w
		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		mov edx, Color

		nop						// AGIXg[
		nop

	loop_x0:

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x0				// (np)


	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		mov edx, Color

		push edi				// [vJE^ޔ
		nop						// AGIXg[

	loop_x_down:

		// ̔~`
		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop edi					// (np) [vJE^

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		mov edx, Color

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_up			// (np) AGIXg[͂ŉƁc

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗lK|W]
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Nega( int x, int y, int nWidth, int nHeight )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	__asm
	{
		mov edi, pBits
		mov esi, dwAddWidth

		mov ecx, nWidth			// X[vJE^
		mov edx, nHeight		// Y[vJE^

	loop_x:

		mov eax, [edi]
		add edi, 4

		xor eax, __xRGB_MASK		// ͔]Ȃ

		mov [edi-4], eax

		dec ecx
		jne loop_x

		add edi, esi
		mov ecx, nWidth

		dec edx
		jne loop_x

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗UCN
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	int nBlockWidthcubN̕
|	int nBlockHeightcubN̍
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLBase::Mosaic( int x, int y, int nWidth, int nHeight, int nBlockWidth, int nBlockHeight )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( nBlockWidth == 0 || nBlockHeight == 0 ) return S_OK;
	
	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	if( nBlockWidth < 0 )  nBlockWidth  = -nBlockWidth;
	if( nBlockHeight < 0 ) nBlockHeight = -nBlockHeight;

	LONG nRight  = x+nWidth;
	LONG nBottom = y+nHeight;

/*
	int bh, bw;
	SDIB32GLCOLOR argb;

	for( int yy = y; yy < nBottom; yy+=nBlockHeight )
	{
		bh = (nBottom-yy >= nBlockHeight) ? (nBlockHeight) : (nBottom-yy);

		for( int xx = x; xx < nRight; xx+=nBlockWidth )
		{
			bw = (nRight-xx >= nBlockWidth) ? (nBlockWidth) : (nRight-xx);

			argb = ppScanLine[yy][xx];

			for( int j=0; j<bh; j++ )
			{
				for( int i=0; i<bw; i++ )
				{
					ppScanLine[j+yy][i+xx]=argb;
				}
			}
		}
	}
*/

	__asm
	{
		mov ecx, y					// ]YW
		mov edi, ppScanLine			// obt@

	loop_y:

		mov edx, x					// ]XW
		mov ebx, nBottom

		sub ebx, ecx				// (np) nBottom-y [oꍇ̒lubN̍

		cmp ebx, nBlockHeight		// nBottom-y < nBlockHeight [̒[
		jl loop_x

		mov ebx, nBlockHeight		// ʏ펞̃ubN̍

	loop_x:

		push ecx					// YWۑ
		push edi					// obt@ۑ

		push ebx					// ubN̍ۑ
		mov esi, [edi+ecx*4]		// ppScanLine[y]
		
		mov esi, [esi+edx*4]		// argb = ppScanLine[y][x]
		mov eax, nRight

		and esi, __xRGB_MASK
		lea edi, [edi+ecx*4]		// &ppScanLine[y]

		sub eax, edx				// nRight-x [oꍇ̒lubN̕

		cmp eax, nBlockWidth		// nRight-x < nBlockWidth E[̒[
		jl block_loop_y

		mov eax, nBlockWidth		// ʏ펞̃ubN̕

	block_loop_y:

		push edx					// XWۑ
		push eax					// ubN̕ۑ

	block_loop_x:

		push edi
		mov ecx, [edi]				// (np) ppScanLine[y]
		
		mov edi, [ecx+edx*4]
		inc edx

		and edi, __Axxx_MASK

		or edi, esi
		dec eax

		mov [ecx+edx*4-4], edi		// ppScanLine[y][x] = argb
		pop edi
		
		jne block_loop_x

		pop eax						// ubN̕A
		pop edx						// XWA

		add edi, 4					// ppScanLine[y++]
		dec ebx	

		jne block_loop_y			// (np)

		pop ebx						// ubN̍A
		pop edi						// obt@A

		pop ecx						// YWA
		add edx, nBlockWidth		// ubN̕Z
		
		cmp edx, nRight
		jl loop_x

		add ecx, nBlockHeight		// (np) ubN̍Z

		cmp ecx, nBottom
		jl loop_y

	}

	return S_OK;
}
