
/******************************************************************************
*	SDIB32GLPMMX Class
******************************************************************************/

#include "stdafx.h"
#include "sdib32gl.h"
#include "sdib32glbase.h"
#include "sdib32glpmmx.h"


/*----------------------------------------------------------------------------*
|	ufBO MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0				<u>
			mov esi, pSrcBits				// ]AhX	<v>

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX	<v>

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.nSrcAddDirX
			mov ebx, Status.nSrcAddDirY

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			movd mm0, [esi]					// ]sNZo
			add esi, eax					// ~[]XZς

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0

			add esi, ebx					// ̃C ~[]YZς
			add edi, edx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

			emms
		}

	}else
	{
		// Y[]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0				<u>
			mov esi, pSrcBits				// ]AhX	<v>

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX	<v>

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, Status.nMx

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm0, [esi]					// ]sNZo
			add esi, Status.nSrcAddRx		// k̓]XZ

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@

			paddw mm0, mm1					// Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]WXɐi߂

			packuswb mm0, mm6				// 00 00 AR GB
			add eax, edx					// X̌덷Z

			movd [edi-4], mm0				// ]sNZɕ`
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	߃ufBO MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::ColorKeyAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0				<u>
			mov esi, pSrcBits				// ]AhX	<v>

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX	<v>

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.nSrcAddDirX
			mov ebx, Status.nSrcAddDirY

			mov edx, ColorKey

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			cmp edx, [esi]
			je skip_draw0

			movd mm0, [esi]					// (np) ]sNZo

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			paddw mm0, mm1					// Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// (np) ]sNZɕ`

		skip_draw0:

			add esi, eax					// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

			add esi, ebx					// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

			emms
		}

	}else
	{
		// Y[]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0				<u>
			mov esi, pSrcBits				// ]AhX	<v>

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX	<v>

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, ColorKey

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			cmp edx, [esi]
			je skip_draw1

			movd mm0, [esi]					// ]sNZo
			
			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			paddw mm0, mm1					// Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B
			
			packuswb mm0, mm6				// (np) 00 00 AR GB
			
			movd [edi], mm0					// (np) ]sNZɕ`

		skip_draw1:

			add esi, Status.nSrcAddRx		// k̓]XZ
			add edi, 4						// ]WXɐi߂

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AddBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

			mov eax, Status.nSrcAddDirY
			mov ebx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// ~[]XZς	<v>

			movd mm1, [edi]					// ]sNZo			<u>
			add edi, 4						// ]͒ʏ					<v>

			paddusb mm1, mm0				// Dst=Dst+Src Z
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			jns loop_x0						//									<v>

			add esi, eax					// ̃C ~[]YZς
			add edi, ebx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

			emms
		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddRx

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// k̓]XZ		<v>

			movd mm1, [edi]					// ]sNZo			<u>
			add edi, 4						// ]͒ʏ					<v>

			paddusb mm1, mm0				// Dst=Dst+Src Z
			add eax, Status.nMx				// X̌덷Z

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			js skip_addsrcx					//									<v>

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AddAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov esi, pSrcBits				// ]AhX

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

			mov eax, Status.nSrcAddDirY
			mov ebx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)
				
		loop_x0:
		
			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// ~[]XZς	<v>

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>
			
			pmullw mm0, mm4					// Src = Src * SrcAt@
			add edi, 4						// ]͒ʏ

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B
			
			packuswb mm0, mm6				// (np) 00 00 AR GB 

			paddusb mm1, mm0				// Dst=Dst+Src Z
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			jns loop_x0						//									<v>

			add esi, eax					// ̃C ~[]YZς
			add edi, ebx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

			emms
		}

	}else
	{
		// Y[]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov esi, pSrcBits				// ]AhX

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddRx

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// k̓]XZ		<v>

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>
			
			pmullw mm0, mm4					// Src = Src * SrcAt@
			add edi, 4						// ]͒ʏ

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B
			
			packuswb mm0, mm6				// (np) 00 00 AR GB 

			paddusb mm1, mm0				// Dst=Dst+Src Z
			add eax, Status.nMx				// X̌덷Z

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			js skip_addsrcx					//									<v>

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::SubBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

			mov eax, Status.nSrcAddDirY
			mov ebx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// ~[]XZς	<v>

			movd mm1, [edi]					// ]sNZo			<u>
			add edi, 4						// ]͒ʏ					<v>

			psubusb mm1, mm0				// Dst=Dst-Src Z
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			jns loop_x0						//									<v>

			add esi, eax					// ̃C ~[]YZς
			add edi, ebx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

			emms
		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddRx

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// k̓]XZ		<v>

			movd mm1, [edi]					// ]sNZo			<u>
			add edi, 4						// ]͒ʏ					<v>

			psubusb mm1, mm0				// Dst=Dst-Src Z
			add eax, Status.nMx				// X̌덷Z

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			js skip_addsrcx					//									<v>

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::SubAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@


	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov esi, pSrcBits				// ]AhX

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

			mov eax, Status.nSrcAddDirY
			mov ebx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)
				
		loop_x0:
		
			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// ~[]XZς	<v>

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>
			
			pmullw mm0, mm4					// Src = Src * SrcAt@
			add edi, 4						// ]͒ʏ

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B
			
			packuswb mm0, mm6				// (np) 00 00 AR GB 

			psubusb mm1, mm0				// Dst=Dst-Src Z
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			jns loop_x0						//									<v>

			add esi, eax					// ̃C ~[]YZς
			add edi, ebx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0

			emms
		}

	}else
	{
		// Y[]

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov esi, pSrcBits				// ]AhX

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddRx

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm0, [esi]					// ]sNZo			<u>
			add esi, edx					// k̓]XZ		<v>

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>
			
			pmullw mm0, mm4					// Src = Src * SrcAt@
			add edi, 4						// ]͒ʏ

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B
			
			packuswb mm0, mm6				// (np) 00 00 AR GB 

			psubusb mm1, mm0				// Dst=Dst-Src Z
			add eax, Status.nMx				// X̌덷Z

			movd [edi-4], mm1				// ]sNZɓ]				<u>
			js skip_addsrcx					//									<v>

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l摜] MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	
	if( !Status.bZoom )
	{
		// W]

		__asm
		{
	
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nDstAddY

			mov eax, Status.nSrcAddDirX
			mov ebx, Status.nSrcAddDirY

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			movd mm4, [esi]					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, eax					// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0

			add esi, ebx					// ̃C ~[]YZς
			add edi, edx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

			emms
		}

	}else
	{

		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, Status.nMx
			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm4, [esi]					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			add eax, edx					// X̌덷Z

			movd [edi-4], mm0				// ]sNZɕ`
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l摜ufBO] - MMX
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AlphaChannelAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	DWORD dwAlpha = CONVERT_255To256( Alpha );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	
	if( !Status.bZoom )
	{
		// W]

		__asm
		{
	
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nDstAddY

			mov eax, Status.nSrcAddDirX
			mov ebx, Status.nSrcAddDirY

			movd mm3, dwAlpha

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			movd mm4, [esi]					// ]sNZo

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8					// (np)

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, eax					// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0

			add esi, ebx					// ̃C ~[]YZς
			add edi, edx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

			emms
		}

	}else
	{

		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, Status.nMx
			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

			movd mm3, dwAlpha

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm4, [esi]					// ]sNZo

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8					// (np)

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			add eax, edx					// X̌덷Z

			movd [edi-4], mm0				// ]sNZɕ`
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l摜] MMX (}XN)
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AlphaChannelMaskBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	
	if( !Status.bZoom )
	{
		// W]

		__asm
		{
	
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nDstAddY

			mov eax, Status.nSrcAddDirX
			mov ebx, Status.nSrcAddDirY

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			movd mm4, [esi]					// ]sNZo
			push ebx

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd ebx, mm4
			movq mm5, mm7					// 256

			cmp ebx, 255					// 255̎͒ʏ`
			je normal_draw0

			cmp ebx, 0						// 0͕̎`悵Ȃ
			je skip_draw0

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, eax					// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			pop ebx
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0

			jmp next_line0

		normal_draw0:

			movd [edi], mm2
			pop ebx

			add esi, eax					// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

			jmp next_line0

		skip_draw0:

			pop ebx

			add esi, eax					// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

		next_line0:

			add esi, ebx					// ̃C ~[]YZς
			add edi, edx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

			emms
		}

	}else
	{

		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm4, [esi]					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd edx, mm4

			cmp edx, 255					// 255̎͒ʏ`
			je normal_draw1

			cmp edx, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			add eax, Status.nMx				// X̌덷Z

			movd [edi-4], mm0				// ]sNZɕ`
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		normal_draw1:						// ʏ`

			movd mm0, [esi]
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			movd [edi], mm0
			add eax, Status.nMx				// X̌덷Z

			lea edi, [edi+4]
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		skip_draw1:							// `悵Ȃ
			
			add edi, 4
			add esi, Status.nSrcAddRx		// k̓]XZ

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

		next_line1:

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l摜ufBO] - MMX (}XN)
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::AlphaChannelMaskAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	DWORD dwAlpha = CONVERT_255To256( Alpha );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	
	if( !Status.bZoom )
	{
		// W]

		__asm
		{
	
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nDstAddY

			mov eax, Status.nSrcAddDirX
			mov ebx, Status.nSrcAddDirY

			movd mm3, dwAlpha

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			movd mm4, [esi]					// ]sNZo
			push ebx

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8					// (np)

			movd ebx, mm4

			cmp ebx, 256					// 256̎͒ʏ`
			je normal_draw0

			cmp ebx, 0						// 0͕̎`悵Ȃ
			je skip_draw0

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, eax					// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src
			pop ebx

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0

			jmp next_line0

		normal_draw0:

			movd [edi], mm0
			pop ebx

			add esi, eax					// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

			jmp next_line0

		skip_draw0:

			pop ebx
			add esi, eax					// ~[]XZς

			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0

		next_line0:

			add esi, ebx					// ̃C ~[]YZς
			add edi, edx					// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

			emms
		}

	}else
	{

		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			movd mm3, dwAlpha
			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			movd mm4, [esi]					// ]sNZo

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, [esi]					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8					// (np)

			movd edx, mm4

			cmp edx, 256					// 256̎͒ʏ`
			je normal_draw1

			cmp edx, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			add eax, Status.nMx				// X̌덷Z

			movd [edi-4], mm0				// ]sNZɕ`
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		normal_draw1:

			movd [edi], mm0
			add esi, Status.nSrcAddRx		// k̓]XZ

			add edi, 4
			add eax, Status.nMx

			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		skip_draw1:

			add edi, 4
			add esi, Status.nSrcAddRx		// k̓]XZ

			add eax, Status.nMx
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

		next_line1:

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ufBO]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0							<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)	<v>

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX	<v>

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY
			pxor mm6, mm6					// = 0 0 0 0

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			pmullw mm0, mm4					// Src = Src * SrcAt@v
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B
			
			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@
			pop eax							// Œ菬yX^bNo

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZf[^ɓ]

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0				<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

			pxor mm6, mm6					// = 0 0 0 0

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			pmullw mm0, mm4					// Src = Src * SrcAt@
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@
			pop esi

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZf[^ɓ]

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]߃ufBO]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateColorKeyAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0							<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)	<v>

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX	<v>

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, ColorKey
			pxor mm6, mm6					// = 0 0 0 0

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]
			
			cmp edx, [esi+eax*4]
			je skip_draw0_colkey

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			pmullw mm0, mm4					// Src = Src * SrcAt@v
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B
			
			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZf[^ɓ]

	skip_draw0_colkey:

			pop ebx							// Œ菬xX^bNo
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0				<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			movd mm5, dwAlphaDst			// 00  0(1-)			<u>
			mov edi, pDstBits				// ]AhX

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

			pxor mm6, mm6					// = 0 0 0 0

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			cmp esi, ColorKey
			je skip_draw1_colkey

			movd mm0, esi					// ]sNZf[^擾

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			pmullw mm0, mm4					// Src = Src * SrcAt@
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZf[^ɓ]

	skip_draw1_colkey:

			pop esi

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]Z]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAddBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm1, [edi]					// ]sNZo
			pop eax							// Œ菬yX^bNo
			
			paddusb mm1, mm0				// Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm1, [edi]					// ]sNZo
			pop esi

			paddusb mm1, mm0				// (np) Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ZufBO]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAddAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>
			
			pmullw mm0, mm4					// Src = Src * SrcAt@
			pop eax							// Œ菬yX^bNo

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR G

			paddusb mm1, mm0				// Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>

			pmullw mm0, mm4					// Src = Src * SrcAt@
			pop esi

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB 

			paddusb mm1, mm0				// (np) Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]Z]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateSubBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm1, [edi]					// ]sNZo
			pop eax							// Œ菬yX^bNo
			
			psubusb mm1, mm0				// Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm1, [edi]					// ]sNZo
			pop esi

			psubusb mm1, mm0				// (np) Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ZufBO]
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateSubAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>
			
			pmullw mm0, mm4					// Src = Src * SrcAt@
			pop eax							// Œ菬yX^bNo

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR G

			psubusb mm1, mm0				// Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movd mm4, dwAlphaSrc			// 00  0
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			punpcklwd mm4, mm4				// 0 0 
			mov edi, pDstBits				// ]AhX

			punpckldq mm4, mm4				// 0 0 0 0
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			movd mm0, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm1, [edi]					// ]sNZo			<u>
			punpcklbw mm0, mm6				// 0A 0R 0G 0B						<v>

			pmullw mm0, mm4					// Src = Src * SrcAt@
			pop esi

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB 

			psubusb mm1, mm0				// (np) Dst=Dst+Src Z

			movd [edi], mm1					// ]sNZɓ]

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]`l摜] MMX
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	
	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp	<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)	<v>

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0v

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm4, esi					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			pop eax							// Œ菬yX^bNo

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp	<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm4, esi					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			pop esi

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]`l摜ufBO] MMX
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	DWORD dwAlpha = CONVERT_255To256( Alpha );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY
			movd mm3, dwAlpha

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo
			
			movd mm4, esi					// ]sNZo
			pop eax							// Œ菬yX^bNo

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8					// (np)

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@

			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()
			
			movd mm3, dwAlpha

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			movd mm4, esi					// ]sNZo

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8
			pop esi

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@

			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]`l摜] MMX (}XN)
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelMaskBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	
	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp	<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)	<v>

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0v

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw_clip0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw_clip0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw_clip0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw_clip0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo

			movd mm4, esi					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd eax, mm4

			cmp eax, 255					// 255̎͒ʏ`
			je normal_draw0

			cmp eax, 0						// 0͕̎`悵Ȃ
			je skip_draw0

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			pop eax							// Œ菬yX^bNo

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

		skip_draw_clip0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			jmp next_line0

		normal_draw0:

			mov [edi], esi
			pop eax

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy

			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			jmp next_line0

		skip_draw0:

			pop eax
			add edi, 4						// ]͒ʏ

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			sub ecx, __DEC_WIDTH
			jns loop_x0						// (np)

		next_line0:

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp	<u>
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw_clip1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw_clip1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw_clip1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw_clip1
			
			push ebx
			push esi						//

			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]

			movd mm4, esi					// ]sNZo
			movq mm5, mm7					// 256

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd ebx, mm4

			cmp ebx, 256					// 256̎͒ʏ`
			je normal_draw1

			cmp ebx, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			pop esi

			paddw mm0, mm1					// (np) Dst = Dst + Src
			pop ebx

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

		skip_draw_clip1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		normal_draw1:

			mov [edi], esi
			pop esi

			add edi, 4						// ]͒ʏ
			pop ebx

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			sub ecx, __DEC_WIDTH			//									<v>

			jns loop_x1

			jmp next_line1

		skip_draw1:

			pop esi
			add edi, 4						// ]͒ʏ

			pop ebx
			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			sub ecx, __DEC_WIDTH			//									<v>

			jns loop_x1

		next_line1:

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]`l摜ufBO] MMX (}XN)
|
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelMaskAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	DWORD dwAlpha = CONVERT_255To256( Alpha );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpckldq mm4, mm4				// 0 0 0 0
			punpckldq mm5, mm5				// 0(1-) 0(1-) 0(1-) 0(1-)

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

			mov edx, Status.nDstAddY
			movd mm3, dwAlpha

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw_clip0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw_clip0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw_clip0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw_clip0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			pop ebx							// Œ菬xX^bNo
			
			movd mm4, esi					// ]sNZo

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8					// (np)

			movd eax, mm4

			cmp eax, 256					// 256̎͒ʏ`
			je normal_draw0

			cmp eax, 0						// 0͕̎`悵Ȃ
			je skip_draw0

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@

			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@
			pop eax							// Œ菬yX^bNo

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

		skip_draw_clip0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			jmp next_line0

		normal_draw0:

			movd [edi], mm0
			pop eax

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			jmp next_line0

		skip_draw0:

			pop eax

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

		next_line0:

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, edx					// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

			emms
		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()
			
			movd mm3, dwAlpha

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw_clip1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw_clip1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw_clip1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw_clip1
			
			push ebx
			push esi						//
			
			mov esi, ppSrcScanLine			// (np) ]AhX
			
			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			movd mm4, esi					// ]sNZo

			movd mm2, esi					// ]sNZo
			psrld mm4, 24					// `l擾

			movd mm0, esi					// ]sNZo
			psrld mm2, 31					// ŏʃrbg擾

			movd mm1, [edi]					// ]sNZo
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4					// Rs[
			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN
			movq mm5, mm7					// 256

			psrld mm4, 8
			pop esi

			movd ebx, mm4

			cmp ebx, 256					// 256̎͒ʏ`
			je normal_draw1

			cmp ebx, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			punpcklwd mm4, mm4				// 0A 0A
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@

			pmullw mm1, mm5					// (np) Dst = Dst * DstAt@
			pop ebx

			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// (np) E8Vtg 0A 0R 0G 0B

			packuswb mm0, mm6				// (np) 00 00 AR GB

			movd [edi], mm0					// ]sNZɕ`

		skip_draw_clip1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1
			
			jmp next_line1

		normal_draw1:

			movd [edi], mm0

			pop ebx
			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		skip_draw1:

			pop ebx
			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

		next_line1:

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	jo[TgWV]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	LPSDIB32GL lpRuleSDIB32GLc[摜w肵܂B]ƓTCYŃO[XP[摜łȂ΂Ȃ܂B
|	WORD wPhasecgWV̕ωʂ0(؂ւO)`65535(Sɐ؂ւ)ŎwB
|	BYTE Vaguec܂l1`255Ŏw肵܂B͉摜̐؂ւ苫Eɉe܂B[摜ɂ킹Ďw肵܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::UniversalTransBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPSDIB32GL lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	_ASSERTE( lpRuleSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;
	if( lpRuleSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc  = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	CSDib32GLPMMX* lpRule = safe_cast( CSDib32GLPMMX*, lpRuleSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );
	INVALIDOBJECTCHECK( lpRule );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );
	_ASSERTE( lpRule->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpRule->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// [摜̃TCY`FbN
	if( lpRule->m_nWidth != m_nWidth ) return SDIB32GLERR_INVALIDPARAMS;
	if( lpRule->m_nHeight != m_nHeight ) return SDIB32GLERR_INVALIDPARAMS;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256

	// [摜̊JnAhX
	SDIB32GLRULESTATUS RuleStatus;
	InitRuleStatus( RuleStatus, Status, dwRuleFlags );
	LPSDIB32GLCOLOR pRuleBits = &lpRule->m_ppScanLine[ RuleStatus.nY ][ RuleStatus.nX ];

	// OCXP[𒼐ڃɂĂ255iK̃e[u쐬č
	DWORD TransTbl[256];
	InitUniversalTransTable( TransTbl, wPhase, Vague );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, pRuleBits				// [摜AhX

			lea ebx, TransTbl				// gWVe[u[h

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			mov eax, [edx]					// [f[^擾
			
			and eax, 0x000000FF				// vfo
			add edx, RuleStatus.nAddDirX	// [f[^ɂ

			mov eax, [ebx+eax*4]			// e[uQ

			cmp eax, 256					// 256̎͒ʏ`
			je normal_draw0

			cmp eax, 0						// 0͕̎`悵Ȃ
			je skip_draw0
			
			movd mm4, eax
			movq mm5, mm7

			movd mm0, [esi]					// ]sNZo
			punpcklwd mm4, mm4				// 0A 0A

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddDirX		// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0
			
			jmp next_line0

		normal_draw0:

			mov eax, [esi]

			mov [edi], eax
			add esi, Status.nSrcAddDirX		// ~[]XZς

			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH
			
			jns loop_x0
			jmp next_line0

		skip_draw0:

			add esi, Status.nSrcAddDirX		// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

		next_line0:

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			add edx, RuleStatus.nAddDirY	// [摜̃C
			sub ecx, __DEC_HEIGHT

			jns loop_y0	

			emms
		}

	}else
	{
		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, pRuleBits				// [摜AhX
			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov ebx, [edx]					// [f[^擾
			lea eax, TransTbl				// gWVe[u[h

			and ebx, 0x000000FF				// vfo
			add edx, RuleStatus.nAddDirX	// [f[^ɂ

			mov ebx, [eax+ebx*4]			// e[uQ

			cmp ebx, 256					// 256̎͒ʏ`
			je normal_draw1

			cmp ebx, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			movd mm4, ebx
			movq mm5, mm7

			movd mm0, [esi]					// ]sNZo
			punpcklwd mm4, mm4				// 0A 0A

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			pop ebx

			movd [edi-4], mm0				// ]sNZɕ`
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		normal_draw1:						// ʏ`

			mov eax, [esi]
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			mov [edi], eax
			pop ebx

			add edi, 4
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		skip_draw1:							// `悵Ȃ
			
			add edi, 4
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			pop ebx
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

		next_line1:			

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add edx, RuleStatus.nAddDirY	// [摜̃C
			add ebx, Status.nMy				// Y̌덷Z

			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	J[L[tjo[TgWV]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	LPSDIB32GL lpRuleSDIB32GLc[摜w肵܂B]ƓTCYŃO[XP[摜łȂ΂Ȃ܂B
|	WORD wPhasecgWV̕ωʂ0(؂ւO)`65535(Sɐ؂ւ)ŎwB
|	BYTE Vaguec܂l1`255Ŏw肵܂B͉摜̐؂ւ苫Eɉe܂B[摜ɂ킹Ďw肵܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::UniversalTransColorKeyBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPSDIB32GL lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	_ASSERTE( lpRuleSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;
	if( lpRuleSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc  = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	CSDib32GLPMMX* lpRule = safe_cast( CSDib32GLPMMX*, lpRuleSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );
	INVALIDOBJECTCHECK( lpRule );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );
	_ASSERTE( lpRule->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpRule->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// [摜̃TCY`FbN
	if( lpRule->m_nWidth != m_nWidth ) return SDIB32GLERR_INVALIDPARAMS;
	if( lpRule->m_nHeight != m_nHeight ) return SDIB32GLERR_INVALIDPARAMS;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [摜̊JnAhX
	SDIB32GLRULESTATUS RuleStatus;
	InitRuleStatus( RuleStatus, Status, dwRuleFlags );
	LPSDIB32GLCOLOR pRuleBits = &lpRule->m_ppScanLine[ RuleStatus.nY ][ RuleStatus.nX ];

	// OCXP[𒼐ڃɂĂ255iK̃e[u쐬č
	DWORD TransTbl[256];
	InitUniversalTransTable( TransTbl, wPhase, Vague );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, pRuleBits				// [摜AhX

			lea ebx, TransTbl				// gWVe[u[h

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			mov eax, [esi]					// ]sNZo

			cmp eax, ColorKey				// J[L[`FbN 
			je skip_draw_colorkey0

			mov eax, [edx]					// [f[^擾
			
			and eax, 0x000000FF				// vfo
			add edx, RuleStatus.nAddDirX	// [f[^ɂ

			mov eax, [ebx+eax*4]			// e[uQ

			cmp eax, 256					// 256̎͒ʏ`
			je normal_draw0

			cmp eax, 0						// 0͕̎`悵Ȃ
			je skip_draw0
			
			movd mm4, eax
			movq mm5, mm7

			movd mm0, [esi]					// ]sNZo
			punpcklwd mm4, mm4				// 0A 0A

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddDirX		// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0
			
			jmp next_line0

		normal_draw0:

			mov eax, [esi]

			mov [edi], eax
			add esi, Status.nSrcAddDirX		// ~[]XZς

			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH
			
			jns loop_x0
			jmp next_line0

		skip_draw_colorkey0:

			add edx, RuleStatus.nAddDirX

		skip_draw0:

			add esi, Status.nSrcAddDirX		// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

		next_line0:

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			add edx, RuleStatus.nAddDirY	// [摜̃C
			sub ecx, __DEC_HEIGHT

			jns loop_y0	

			emms
		}

	}else
	{
		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, pRuleBits				// [摜AhX
			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov eax, [esi]					// ]sNZo

			cmp eax, ColorKey				// J[L[`FbN 
			je skip_draw_colorkey1

			mov ebx, [edx]					// [f[^擾
			lea eax, TransTbl				// gWVe[u[h

			and ebx, 0x000000FF				// vfo
			add edx, RuleStatus.nAddDirX	// [f[^ɂ

			mov ebx, [eax+ebx*4]			// e[uQ

			cmp ebx, 256					// 256̎͒ʏ`
			je normal_draw1

			cmp ebx, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			movd mm4, ebx
			movq mm5, mm7

			movd mm0, [esi]					// ]sNZo
			punpcklwd mm4, mm4				// 0A 0A

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			pop ebx

			movd [edi-4], mm0				// ]sNZɕ`
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		normal_draw1:						// ʏ`

			mov eax, [esi]
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			mov [edi], eax
			pop ebx

			add edi, 4
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		skip_draw_colorkey1:

			add edx, RuleStatus.nAddDirX

		skip_draw1:							// `悵Ȃ
			
			add edi, 4
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			pop ebx
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

		next_line1:

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add edx, RuleStatus.nAddDirY	// [摜̃C
			add ebx, Status.nMy				// Y̌덷Z

			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`ltjo[TgWV]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	LPSDIB32GL lpRuleSDIB32GLc[摜w肵܂B]ƓTCYŃO[XP[摜łȂ΂Ȃ܂B
|	WORD wPhasecgWV̕ωʂ0(؂ւO)`65535(Sɐ؂ւ)ŎwB
|	BYTE Vaguec܂l1`255Ŏw肵܂B͉摜̐؂ւ苫Eɉe܂B[摜ɂ킹Ďw肵܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::UniversalTransAlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, LPSDIB32GL lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	_ASSERTE( lpRuleSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;
	if( lpRuleSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLPMMX* lpSrc  = safe_cast( CSDib32GLPMMX*, lpSrcSDIB32GL );
	CSDib32GLPMMX* lpRule = safe_cast( CSDib32GLPMMX*, lpRuleSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );
	INVALIDOBJECTCHECK( lpRule );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );
	_ASSERTE( lpRule->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpRule->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// [摜̃TCY`FbN
	if( lpRule->m_nWidth != m_nWidth ) return SDIB32GLERR_INVALIDPARAMS;
	if( lpRule->m_nHeight != m_nHeight ) return SDIB32GLERR_INVALIDPARAMS;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	static const DWORD64 _0100010001000100 = 0x0100010001000100;	// 256@256@256@256

	// [摜̊JnAhX
	SDIB32GLRULESTATUS RuleStatus;
	InitRuleStatus( RuleStatus, Status, dwRuleFlags );
	LPSDIB32GLCOLOR pRuleBits = &lpRule->m_ppScanLine[ RuleStatus.nY ][ RuleStatus.nX ];

	// OCXP[𒼐ڃɂĂ255iK̃e[u쐬č
	DWORD TransTbl[256];
	InitUniversalTransTable( TransTbl, wPhase, Vague );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, pRuleBits				// [摜AhX

			lea ebx, TransTbl				// gWVe[u[h

		loop_y0:

			or ecx, Status.nWidth			// (np) ]镝(X[vJE^)

		loop_x0:
		
			movd mm4, [esi]					// ]sNZo
			mov eax, [edx]					// [f[^擾

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			psrld mm2, 31					// ŏʃrbg擾
			and eax, 0x000000FF				// vfo

			movd mm3, [ebx+eax*4]			// e[uQ
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4
			add edx, RuleStatus.nAddDirX	// [f[^ɂ

			pmullw mm4, mm3					// `lɃKp
			
			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN

			psrld mm4, 8					// (np)
			movq mm5, mm7

			movd eax, mm4

			cmp eax, 256					// 256̎͒ʏ`
			je normal_draw0

			cmp eax, 0						// 0͕̎`悵Ȃ
			je skip_draw0

			movd mm0, [esi]					// ]sNZo
			punpcklwd mm4, mm4				// 0A 0A

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddDirX		// ~[]XZς
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0				// ]sNZɕ`
			jns loop_x0
			
			jmp next_line0

		normal_draw0:

			mov eax, [esi]

			mov [edi], eax
			add esi, Status.nSrcAddDirX		// ~[]XZς

			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH
			
			jns loop_x0

			jmp next_line0

		skip_draw0:

			add esi, Status.nSrcAddDirX		// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

		next_line0:

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			add edx, RuleStatus.nAddDirY	// [摜̃C
			sub ecx, __DEC_HEIGHT

			jns loop_y0	

			emms
		}

	}else
	{
		// Y[]
		__asm
		{
			movq mm7, _0100010001000100		// t̃߂ƂɎgp
			mov esi, pSrcBits				// ]AhX
			
			mov edi, pDstBits				// ]AhX
			pxor mm6, mm6					// = 0 0 0 0
		
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov edx, pRuleBits				// [摜AhX
			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			movd mm4, [esi]					// ]sNZo
			mov eax, [edx]					// [f[^擾

			movd mm2, [esi]					// ]sNZo
			psrld mm4, 24					// `l擾

			psrld mm2, 31					// ŏʃrbg擾
			and eax, 0x000000FF				// vfo

			lea ebx, TransTbl
			paddd mm4, mm2					// `l+ŏʃrbg

			movq mm5, mm4
			movd mm3, [ebx+eax*4]			// e[uQ

			pmullw mm4, mm3					// `lɃKp
			add edx, RuleStatus.nAddDirX	// [f[^ɂ

			pmulhw mm5, mm3					// (np) 256*256̌ӂ΍

			punpcklwd mm4, mm5				// ʃ[hƉʃ[hApbN

			psrld mm4, 8					// (np)
			movq mm5, mm7

			movd eax, mm4

			cmp eax, 256					// 256̎͒ʏ`
			je normal_draw1

			cmp eax, 0						// 0͕̎`悵Ȃ
			je skip_draw1

			movd mm0, [esi]					// ]sNZo
			punpcklwd mm4, mm4				// 0A 0A

			movd mm1, [edi]					// ]sNZo
			punpcklbw mm0, mm6				// ] - 0A 0R 0G 0B

			punpckldq mm4, mm4				// 0A 0A 0A 0A
			punpcklbw mm1, mm6				// ] - 0A 0R 0G 0B

			psubw mm5, mm4					// 0(256-A) 0(256-A) 0(256-A) 0(256-A)
			pmullw mm0, mm4					// Src = Src * SrcAt@
			
			add esi, Status.nSrcAddRx		// k̓]XZ
			pmullw mm1, mm5					// Dst = Dst * DstAt@
			
			paddw mm0, mm1					// (np) Dst = Dst + Src

			psrlw mm0, 8					// E8Vtg 0A 0R 0G 0B
			add edi, 4						// ]͒ʏ

			packuswb mm0, mm6				// 00 00 AR GB
			pop ebx

			movd [edi-4], mm0				// ]sNZɕ`
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		normal_draw1:						// ʏ`

			mov eax, [esi]
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			mov [edi], eax
			pop ebx

			add edi, 4
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

			jmp next_line1

		skip_draw1:							// `悵Ȃ
			
			add edi, 4
			add esi, Status.nSrcAddRx		// k̓]XZ
			
			pop ebx
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

			sub ecx, __DEC_WIDTH
			jns loop_x1

		next_line1:
			
			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add edx, RuleStatus.nAddDirY	// [摜̃C
			add ebx, Status.nMy				// Y̌덷Z

			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1

			emms
		}

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`` MMX
|@
|	w肵Fŋ`̈𔼓܂
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RectangleAlpha( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;
	
	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

//	LPSDIB32GLCOLOR pBits = &m_pBits[x+y*m_nWidth];
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];


	// RGBlɃlKp
	__asm
	{
		movd mm4, dwAlphaSrc	// 00  0
		mov edi, pBits			// ݂X,Yobt@AhX

		movd mm5, dwAlphaDst	// 00  0(1-)
		mov esi, dwAddWidth		// ̃CɈړ邽߂̒l

		punpcklwd mm4, mm4		// 0 0 
		punpcklwd mm5, mm5		// 0(1-) 0(1-)

		punpckldq mm4, mm4		// 0 0 0 0
		punpckldq mm5, mm5		// 0(1-) 0(1-) 0(1-) 0(1-)

		movd mm0, Color			// `F = A R G B  <u>
		pxor mm6, mm6			// = 0 0 0 0	     <v>
		
		punpcklbw mm0, mm6		// 0A 0R 0G 0B
		mov ecx, nWidth			// 
		
		pmullw mm0, mm4			// hF~ ő0xFF00
		mov edx, nHeight		// Y[vJE^

		shr ecx, 1				// 2sNZÂ̂ŉE1VtgCFω <u>
		mov eax, ecx			// X[vJE^̒lۑ							<v>

		jnc even_loop_x			// CF1łȂȂ̃[v
		
	uneven_loop_y:
		
		// [sNZ
		movd mm1, [edi]			// (np) ]sNZo
		
		punpcklbw mm1, mm6		// (np)	0A 0R 0G 0B

		pmullw mm1, mm5			// (np) Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		paddw mm1, mm0			// (np) Dst = Dst + Src

		psrlw mm1, 8			// (np) E8Vtg 0A 0R 0G 0B
		add edi, 4				// obt@̃AhXi߂ pBits++;

		packuswb mm1, mm6		// (np) 00 00 AR GB
		cmp ecx, 0				// X[vJE^0(1)̎̃`FbN

		movd [edi-4], mm1		// (np) ]sNZɕ`
		je end_uneven_loop_x	// (np) X[vJE^0͎̎̃C
								// AGIXg[
	uneven_loop_x:
	
		// 2sNZ
		movd mm1, [edi]			// (np) [0] ]sNZo

		movd mm3, [edi+4]		// [1] ]sNZo	<u>
		punpcklbw mm1, mm6		// [0] 0A 0R 0G 0B				<v>

		pmullw mm1, mm5			// [0] Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)
		punpcklbw mm3, mm6		// [1] 0A 0R 0G 0B

		paddw mm1, mm0			// [0] Dst = Dst + Src
		pmullw mm3, mm5			// [1] Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		psrlw mm1, 8			// [0] E8Vtg 0A 0R 0G 0B
		paddw mm3, mm0			// [1] Dst = Dst + Src

		psrlw mm3, 8			// [1] E8Vtg 0A 0R 0G 0B
		add edi, 8				// 2sNẐł̕i߂ (pBits+=2)

		packuswb mm1, mm3		// = AR GB AR GB [1] [0]
		dec ecx					// XJE^ --

		movq [edi-8], mm1		// ]sNZ2sNZ`
		jne uneven_loop_x

	end_uneven_loop_x:

		add edi, esi			// ̃CɈړ (pBits+=dwAddWidth)
		mov ecx, eax			// X[vJE^A

		dec edx					// YJE^ --
		jne uneven_loop_y

		jmp end_				// I


	even_loop_x:

		// 2sNZ
		movd mm1, [edi]			// (np) [0] ]sNZo

		movd mm3, [edi+4]		// [1] ]sNZo	<u>
		punpcklbw mm1, mm6		// [0] 0A 0R 0G 0B				<v>

		pmullw mm1, mm5			// [0] Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)
		punpcklbw mm3, mm6		// [1] 0A 0R 0G 0B

		paddw mm1, mm0			// [0] Dst = Dst + Src
		pmullw mm3, mm5			// [1] Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		psrlw mm1, 8			// [0] E8Vtg 0A 0R 0G 0B
		paddw mm3, mm0			// [1] Dst = Dst + Src

		psrlw mm3, 8			// [1] E8Vtg 0A 0R 0G 0B
		add edi, 8				// 2sNẐł̕i߂ (pBits+=2)

		packuswb mm1, mm3		// = AR GB AR GB [1] [0]
		dec ecx					// XJE^ --

		movq [edi-8], mm1		// ]sNZ2sNZ`
		jne even_loop_x

		add edi, esi			// ̃CɈړ (pBits+=dwAddWidth)
		mov ecx, eax			// X[vJE^A

		dec edx					// YJE^ --
		jne even_loop_x

	end_:

		emms

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z`` MMX
|
|	w肵Fŋ`̈Z܂
|	lw肷邱ƂŔZ\
|@
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RectangleAdd( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(0,0,0) 
	if( !(Color&__Axxx_MASK) || !(Color&__xRGB_MASK) ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

//	LPSDIB32GLCOLOR pBits = &m_pBits[x+y*m_nWidth];
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];

	__asm
	{
		movd mm4, dwAlphaSrc	// 00  0						<u>
		mov edi, pBits			// ݂X,Yobt@AhX	<v>

		movd mm0, Color			// `F = A R G B				<u>
		mov esi, dwAddWidth		// ̃CɈړ邽߂̒l	<v>

		punpcklwd mm4, mm4		// 0 0 
		pxor mm6, mm6			// mm3 = 0 0 0 0
		
		punpckldq mm4, mm4		// 0 0 0 0
		punpcklbw mm0, mm6		// 0A 0R 0G 0B

		pmullw mm0, mm4			// hF~ ő0xFF00
		mov ecx, nWidth			// 

		psrlw mm0, 8			// E8Vtg 0A 0R 0G 0B
		mov edx, nHeight		// Y[vJE^

		shr ecx, 1				// 2sNZÂ̂ŉE1VtgCFω	<u>
		packuswb mm0, mm6		// ]KpF									<v>
/*
2003.12.12
		movq mm2, mm0			// Rs[
		punpckldq mm2, mm2		// AR GB AR GB
*/
		
		mov eax, ecx			// X[vJE^̒lۑ
		jnc even_loop_x			// CF1łȂȂ̃[v

	uneven_loop_y:

		// [sNZ
		movd mm1, [edi]			// ]sNZo
		add edi, 4

		paddusb mm1, mm0		// Dst=Dst+Src Z
		cmp ecx, 0

		movd [edi-4], mm1		//
		je end_uneven_loop_x	//

	uneven_loop_x:


		// 2sNZ
		movd mm1, [edi]			// (np)
		
		movd mm3, [edi+4]
		paddusb mm1, mm0		// Dst=Dst+Src Z

		movd [edi], mm1
		paddusb mm3, mm0		// Dst=Dst+Src Z

		movd [edi+4], mm3		//
		
		add edi, 8				// 2sNẐł̕i߂ (pBits+=2)
		dec ecx					// XJE^ --

		jne uneven_loop_x		//
/*
2003.12.12
		// d݂ł
		// 4oCgEH܂32oCg̃LbV~XȁEEE
2004.1.20
		// MMXWX^ł8oCgE܂ƌ
		
		movq mm1, [edi]			// (np) ]2sNZo
		
		paddusb mm1, mm2		// (np) Dst=Dst+Src Z

		movq [edi], mm1			// (np) ]2sNZɕ`
*/
		
	end_uneven_loop_x:

		add edi, esi			// ̃CɈړ (pBits+=dwAddWidth)
		mov ecx, eax			// X[vJE^A

		dec edx					// YJE^ --
		jne uneven_loop_y

	jmp end_					// I

	even_loop_x:

		// 2sNZ
		movd mm1, [edi]			// (np)
		
		movd mm3, [edi+4]
		paddusb mm1, mm0		// Dst=Dst+Src Z

		movd [edi], mm1
		paddusb mm3, mm0		// Dst=Dst+Src Z

		movd [edi+4], mm3		//

		add edi, 8				// 2sNẐł̕i߂ (pBits+=2)
		dec ecx					// XJE^ --

		jne even_loop_x
/*		
2003.12.12
		// d݂ł
		// 4oCgEH܂32oCg̃LbV~XȁEEE
		movq mm1, [edi]			// (np) ]2sNZo

		paddusb mm1, mm2		// (np) Dst=Dst+Src Z

		movq [edi], mm1			// (np) ]2sNZɕ`
*/


		add edi, esi			// ̃CɈړ (pBits+=dwAddWidth)
		mov ecx, eax			// X[vJE^A

		dec edx					// YJE^ --
		jne even_loop_x

	end_:

		emms
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z`` MMX
|	
|	w肵Fŋ`̈Z܂
|	lw肷邱ƂŔZ\
|	
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::RectangleSub( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(255,255,255) 
	if( !(Color&__Axxx_MASK) || (Color&__xRGB_MASK)==__xRGB_MASK ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

//	LPSDIB32GLCOLOR pBits = &m_pBits[x+y*m_nWidth];
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];

	__asm
	{
		movd mm4, dwAlphaSrc	// 00  0						<u>
		mov edi, pBits			// ݂X,Yobt@AhX	<v>

		movd mm0, Color			// `F = A R G B				<u>
		mov esi, dwAddWidth		// ̃CɈړ邽߂̒l	<v>

		punpcklwd mm4, mm4		// 0 0 
		pxor mm6, mm6			// mm3 = 0 0 0 0
		
		punpckldq mm4, mm4		// 0 0 0 0
		punpcklbw mm0, mm6		// 0A 0R 0G 0B

		pmullw mm0, mm4			// hF~ ő0xFF00
		mov ecx, nWidth			// 

		psrlw mm0, 8			// E8Vtg 0A 0R 0G 0B
		mov edx, nHeight		// Y[vJE^

		shr ecx, 1				// 2sNZÂ̂ŉE1VtgCFω	<u>
		packuswb mm0, mm6		// ]KpF									<v>
/*
2003.12.12
		movq mm2, mm0			// Rs[
		punpckldq mm2, mm2		// AR GB AR GB
*/
		
		mov eax, ecx			// X[vJE^̒lۑ
		jnc even_loop_x			// CF1łȂȂ̃[v

	uneven_loop_y:

		// [sNZ
		movd mm1, [edi]			// ]sNZo
		add edi, 4

		psubusb mm1, mm0		// Dst=Dst+Src Z
		cmp ecx, 0

		movd [edi-4], mm1		// 
		je end_uneven_loop_x	// 

	uneven_loop_x:


		// 2sNZ
		movd mm1, [edi]			// (np)
		
		movd mm3, [edi+4]
		psubusb mm1, mm0		// Dst=Dst+Src Z

		movd [edi], mm1
		psubusb mm3, mm0		// Dst=Dst+Src Z

		movd [edi+4], mm3		//

		add edi, 8				// 2sNẐł̕i߂ (pBits+=2)
		dec ecx					// XJE^ --

		jne uneven_loop_x		//
/*
2003.12.12
		// d݂ł
		// 4oCgEH܂32oCg̃LbV~XȁEEE
		movq mm1, [edi]			// (np) ]2sNZo
		
		psubusb mm1, mm2		// (np) Dst=Dst+Src Z

		movq [edi], mm1			// (np) ]2sNZɕ`
*/

	end_uneven_loop_x:

		add edi, esi			// ̃CɈړ (pBits+=dwAddWidth)
		mov ecx, eax			// X[vJE^A

		dec edx					// YJE^ --
		jne uneven_loop_y

	jmp end_					// I

	even_loop_x:

		// 2sNZ
		movd mm1, [edi]			// (np)
		
		movd mm3, [edi+4]
		psubusb mm1, mm0		// Dst=Dst+Src Z

		movd [edi], mm1
		psubusb mm3, mm0		// Dst=Dst+Src Z

		movd [edi+4], mm3		//

		add edi, 8				// 2sNẐł̕i߂ (pBits+=2)
		dec ecx					// XJE^ --

		jne even_loop_x
/*		
2003.12.12
		// d݂ł
		// 4oCgEH܂32oCg̃LbV~XȁEEE
		movq mm1, [edi]			// (np) ]2sNZo

		psubusb mm1, mm2		// (np) Dst=Dst+Src Z

		movq [edi], mm1			// (np) ]2sNZɕ`
*/

		add edi, esi			// ̃CɈړ (pBits+=dwAddWidth)
		mov ecx, eax			// X[vJE^A

		dec edx					// YJE^ --
		jne even_loop_x

	end_:

		emms
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	 (MMX)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::LineAlpha( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;

	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );// t̃At@

	__asm
	{
		movd mm4, dwAlphaSrc	// SrcAt@ 0 0 0  (ۂ͍ő 0x00000100)
		mov edi, dwDx

		movd mm5, dwAlphaDst	// DstAt@ 0 0 0 (1-)
		mov esi, dwDy

		punpcklwd mm4, mm4		// 0  0 
		punpcklwd mm5, mm5		// 0 (1-) 0 (1-)

		punpckldq mm4, mm4		// 0  0  0  0 
		punpckldq mm5, mm5		// 0 (1-) 0 (1-) 0 (1-) 0 (1-) ]At@쐬

		movd mm0, Color			// `F = A R G B  <u>
		pxor mm6, mm6			// mm3 = 0 0 0 0     <v>

		punpcklbw mm0, mm6		// (np) 0A 0R 0G 0B

		pmullw mm0, mm4			// (np) ]At@KpJ[쐬(őff00 ff00 ff00 ff00)
								// v

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np) x1 + dwAx

		mov dwEnd, eax			// dwEnd = x1 + dwAx
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
		
		// `
		mov ecx, ppScanLine		// (np)

		mov edi, [ecx+ebx*4]	// (np) YW̃AhX *(ppScanLine+y)

		movd mm1, [edi+eax*4]	// (np) ]sNZ = *(ppScanLine[y]+x)
		
		punpcklbw mm1, mm6		// (np) 0A 0R 0G 0B

		pmullw mm1, mm5			// (np) Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		paddw mm1, mm0			// (np) Dst = Dst + Src

		psrlw mm1, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm1, mm6		// (np) 00 00 AR GB

		movd [edi+eax*4], mm1	// (np) ]sNZɕ`

	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0
		
		jmp end_loop			// (np) I

	jump_y:
	
		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// dwEnd = y1 + dwAy
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1
		
		// `
		mov ecx, ppScanLine		// (np)

		mov edi, [ecx+ebx*4]	// (np) YW̃AhX *(ppScanLine+y)

		movd mm1, [edi+eax*4]	// (np) ]sNZ = *(ppScanLine[y]+x)
		
		punpcklbw mm1, mm6		// (np) 0A 0R 0G 0B

		pmullw mm1, mm5			// (np) Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		paddw mm1, mm0			// (np) Dst = Dst + Src

		psrlw mm1, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm1, mm6		// (np) 00 00 AR GB

		movd [edi+eax*4], mm1	// (np) ]sNZɕ`

	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:

		emms	// MMXI
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z (MMX)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::LineAdd( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(0,0,0)  
	if( !(Color&__Axxx_MASK) || !(Color&__xRGB_MASK) ) return S_OK;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;

	DWORD dwAlphaSrc = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@

	__asm
	{

		movd mm4, dwAlphaSrc	// 00  0						<u>
		mov edi, dwDx			//								<v>

		movd mm0, Color			// `F = A R G B				<u>
		mov esi, dwDy			//								<v>

		punpcklwd mm4, mm4		// 0 0 
		pxor mm6, mm6			// mm3 = 0 0 0 0
		
		punpckldq mm4, mm4		// 0 0 0 0
		punpcklbw mm0, mm6		// 0A 0R 0G 0B

		pmullw mm0, mm4			// (np) hF~ ő0xFF00

		psrlw mm0, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm0, mm6		// (np) ]KpF

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np) x1 + dwAx

		mov dwEnd, eax			// dwEnd = x1 + dwAx
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
		
		// `
		mov ecx, ppScanLine		// (np)

		mov edi, [ecx+ebx*4]	// (np) YW̃AhX *(ppScanLine+y)

		movd mm1, [edi+eax*4]	// (np) ]sNZ = *(ppScanLine[y]+x)

		paddusb mm1, mm0		// (np) Dst=Dst+Src Z

		movd [edi+eax*4], mm1	// (np)


	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0
		
		jmp end_loop			// (np) I

	jump_y:
	
		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// dwEnd = y1 + dwAy
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1
		
		// `
		mov ecx, ppScanLine		// (np)

		mov edi, [ecx+ebx*4]	// (np) YW̃AhX *(ppScanLine+y)

		movd mm1, [edi+eax*4]	// (np) ]sNZ = *(ppScanLine[y]+x)

		paddusb mm1, mm0		// (np) Dst=Dst+Src Z

		movd [edi+eax*4], mm1	// (np)

	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:

		emms	// MMXI
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z (MMX)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::LineSub( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(255,255,255) 
	if( !(Color&__Axxx_MASK) || (Color&__xRGB_MASK)==__xRGB_MASK ) return S_OK;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;
	DWORD dwAlphaSrc = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@

	__asm
	{

		movd mm4, dwAlphaSrc	// 00  0						<u>
		mov edi, dwDx			//								<v>

		movd mm0, Color			// `F = A R G B				<u>
		mov esi, dwDy			//								<v>

		punpcklwd mm4, mm4		// 0 0 
		pxor mm6, mm6			// mm3 = 0 0 0 0
		
		punpckldq mm4, mm4		// 0 0 0 0
		punpcklbw mm0, mm6		// 0A 0R 0G 0B

		pmullw mm0, mm4			// (np) hF~ ő0xFF00

		psrlw mm0, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm0, mm6		// (np) ]KpF

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np) x1 + dwAx

		mov dwEnd, eax			// dwEnd = x1 + dwAx
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
			
		// `
		mov ecx, ppScanLine		// (np)

		mov edi, [ecx+ebx*4]	// (np) YW̃AhX *(ppScanLine+y)

		movd mm1, [edi+eax*4]	// (np) ]sNZ = *(ppScanLine[y]+x)

		psubusb mm1, mm0		// (np) Dst=Dst+Src Z

		movd [edi+eax*4], mm1	// (np)


	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0
		
		jmp end_loop			// (np) I

	jump_y:
	
		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// dwEnd = y1 + dwAy
		mov eax, x0				// JnXW

		mov ebx, y0				// JnYW
		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1
			
		// `
		mov ecx, ppScanLine		// (np)

		mov edi, [ecx+ebx*4]	// (np) YW̃AhX *(ppScanLine+y)

		movd mm1, [edi+eax*4]	// (np) ]sNZ = *(ppScanLine[y]+x)

		psubusb mm1, mm0		// (np) Dst=Dst+Src Z

		movd [edi+eax*4], mm1	// (np)

	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:

		emms	// MMXI
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ȉ~ (MMX)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::EllipseAlpha( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;

	DWORD dwAlphaSrc = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );// t̃At@

	__asm
	{
		movd mm4, dwAlphaSrc	// SrcAt@ 0 0 0  (ۂ͍ő 0x00000100)@	<u>
		mov ecx, rx				//														<v>

		movd mm5, dwAlphaDst	// DstAt@ 0 0 0 (1-)							<u>
		mov edx, ry				//														<v>

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		punpcklwd mm4, mm4		// 0  0 
		punpcklwd mm5, mm5		// 0 (1-) 0 (1-)

		punpckldq mm4, mm4		// 0  0  0  0 
		punpckldq mm5, mm5		// 0 (1-) 0 (1-) 0 (1-) 0 (1-) ]At@쐬

		movd mm0, Color			// `F = A R G B  <u>
		pxor mm6, mm6			// mm3 = 0 0 0 0     <v>

		punpcklbw mm0, mm6		// (np) 0A 0R 0G 0B

		neg ecx					// (np) -(r*ry)

		pmullw mm0, mm4			// ]At@KpJ[쐬(őff00 ff00 ff00 ff00)
		mov edx, ecx			// Rs[

		shl ecx, 1				//				<u>
		mov eax, rx				// JnXW(x)	<v>

		shl edx, 2				//				<u>
		mov ebx, 0				// JnYW(y)	<v>

		add ecx, dw2h
		add edx, dw2w

		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w
		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x0:

		movd mm1, [ecx]			// (np) ]sNZ

		punpcklbw mm1, mm6		// (np) 0A 0R 0G 0B

		pmullw mm1, mm5			// (np) Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		paddw mm1, mm0			// (np) Dst = Dst + Src

		psrlw mm1, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm1, mm6		// (np) 00 00 AR GB

		movd [ecx], mm1			// (np) ]sNZɕ`

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x0				// (np)

	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push edi				// [vJE^ޔ

		nop
		nop						// AGIXg[

	loop_x_down:

		// ̔~`
		movd mm1, [ecx]			// (np) ]sNZ

		punpcklbw mm1, mm6		// (np) 0A 0R 0G 0B

		pmullw mm1, mm5			// (np) Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		paddw mm1, mm0			// (np) Dst = Dst + Src

		psrlw mm1, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm1, mm6		// (np) 00 00 AR GB

		movd [ecx], mm1			// (np) ]sNZɕ`

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop edi					// (np) [vJE^

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		movd mm1, [ecx]			// (np) ]sNZ

		punpcklbw mm1, mm6		// (np) 0A 0R 0G 0B

		pmullw mm1, mm5			// (np) Dst = Dst * DstAt@(őff00 ff00 ff00 ff00)

		paddw mm1, mm0			// (np) Dst = Dst + Src

		psrlw mm1, 8			// (np) E8Vtg 0A 0R 0G 0B

		packuswb mm1, mm6		// (np) 00 00 AR GB

		movd [ecx], mm1			// (np) ]sNZɕ`

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_up			// (np) AGIXg[͂ŉƁc

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

		emms
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Zȉ~ (MMX)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::EllipseAdd( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;

	DWORD dwAlphaSrc = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@

	__asm
	{
		movd mm4, dwAlphaSrc	// 00  0						<u>
		mov ecx, rx				//								<v>

		movd mm0, Color			// `F = A R G B				<u>
		mov edx, ry				//								<v>

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		punpcklwd mm4, mm4		// 0 0 
		pxor mm6, mm6			// mm3 = 0 0 0 0
		
		punpckldq mm4, mm4		// 0 0 0 0
		punpcklbw mm0, mm6		// 0A 0R 0G 0B

		pmullw mm0, mm4			// (np) hF~ ő0xFF00

		neg ecx					// (np) -(r*ry)

		psrlw mm0, 8			// E8Vtg 0A 0R 0G 0B
		mov eax, rx				// JnXW(x)

		packuswb mm0, mm6		// ]KpF
		mov edx, ecx			// Rs[

		shl ecx, 1				//				<u>
		mov ebx, 0				// JnYW(y)	<v>

		shl edx, 2				//				<u>
		add ecx, dw2h			//				<v>

		add edx, dw2w
		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w

		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x0:

		movd mm1, [ecx]			// (np)	]sNZ

		paddusb mm1, mm0		// (np)	Dst=Dst+Src Z

		movd [ecx], mm1			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x0				// (np)


	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push edi				// [vJE^ޔ

		nop
		nop						// AGIXg[

	loop_x_down:

		// ̔~`
		movd mm1, [ecx]			// (np)	]sNZ

		paddusb mm1, mm0		// (np)	Dst=Dst+Src Z

		movd [ecx], mm1			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop edi					// (np) [vJE^

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		movd mm1, [ecx]			// (np)	]sNZ

		paddusb mm1, mm0		// (np)	Dst=Dst+Src Z

		movd [ecx], mm1			// (np) `


		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_up			// (np) AGIXg[͂ŉƁc

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

		emms
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Zȉ~ (MMX)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::EllipseSub( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;

	DWORD dwAlphaSrc = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@

	__asm
	{
		movd mm4, dwAlphaSrc	// 00  0						<u>
		mov ecx, rx				//								<v>

		movd mm0, Color			// `F = A R G B				<u>
		mov edx, ry				//								<v>

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		punpcklwd mm4, mm4		// 0 0 
		pxor mm6, mm6			// mm3 = 0 0 0 0
		
		punpckldq mm4, mm4		// 0 0 0 0
		punpcklbw mm0, mm6		// 0A 0R 0G 0B

		pmullw mm0, mm4			// (np) hF~ ő0xFF00

		neg ecx					// (np) -(r*ry)

		psrlw mm0, 8			// E8Vtg 0A 0R 0G 0B
		mov eax, rx				// JnXW(x)

		packuswb mm0, mm6		// ]KpF
		mov edx, ecx			// Rs[

		shl ecx, 1				//				<u>
		mov ebx, 0				// JnYW(y)	<v>

		shl edx, 2				//				<u>
		add ecx, dw2h			//				<v>

		add edx, dw2w
		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w

		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x0:

		movd mm1, [ecx]			// (np)	]sNZ

		psubusb mm1, mm0		// (np)	Dst=Dst-Src Z

		movd [ecx], mm1			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x0				// (np)


	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push edi				// [vJE^ޔ

		nop
		nop						// AGIXg[

	loop_x_down:

		// ̔~`
		movd mm1, [ecx]			// (np)	]sNZ

		psubusb mm1, mm0		// (np)	Dst=Dst-Src Z

		movd [ecx], mm1			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop edi					// (np) [vJE^

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		movd mm1, [ecx]			// (np)	]sNZ

		psubusb mm1, mm0		// (np)	Dst=Dst-Src Z

		movd [ecx], mm1			// (np) `


		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_up			// (np) AGIXg[͂ŉƁc

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

		emms
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗mN
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	BYTE Strengthc 0ŃtJ[A255ŊSmN
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::Mono( int x, int y, int nWidth, int nHeight, BYTE Strength )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( Strength == 0 ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	nWidth  = CONVERT_WIDTH( nWidth );
	nHeight = CONVERT_HEIGHT( nHeight );

	static const DWORD64 qwY_RGB = 0x0000004d0097001c;
	static const DWORD64 qwAlphaMask = 0x0000000001000000;

	LPSDIB32GLCOLOR lpMonoTbl = m_MonoTbl;


	if( Strength != 255 )
	{
		DWORD dwStrength1 = CONVERT_255To256(Strength);
		DWORD dwStrength2 = DEST_ALPHA(dwStrength1);

		__asm
		{	
			movd mm4, dwStrength1			// 00  0				<u>
			mov edi, pBits					//						<v>

			movd mm5, dwStrength2			// 00  0(1-)			<u>
			mov ecx, nHeight				// X[vJE^		<v>

			movq mm0, mm4
			movq mm1, mm5
 
			por mm1, qwAlphaMask

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpcklwd mm4, mm0				// 00 0 0 0
			punpcklwd mm5, mm1				// 01 0(1-) 0(1-) 0(1-)

			mov esi, lpMonoTbl
			pxor mm6, mm6

		loop_y0:

			or ecx, nWidth

		loop_x0:

			movd mm0, [edi]			// sNZf[^擾
			mov edx, [edi]			// sNZf[^擾

			punpcklbw mm0, mm6		// 0A 0R 0G 0B
			add edi, 4

			pmullw mm0, qwY_RGB		// 00 RR GG BB
			and edx, __Axxx_MASK

			movq mm1, mm0			// MM1 = 00 RR GG BB Rs[
			punpcklwd mm0, mm6		// MM0 = 00 GG 00 BB

			movq mm2, mm0			// MM2 = 00 GG 00 BB Rs[
			punpckhwd mm1, mm6		// MM1 = 00 00 00 RR

			paddd mm0, mm1			// 00 GG 00 BB+RR
			punpckhwd mm2, mm6		// MM2 = 00 00 00 GG

			paddd mm0, mm2			// (np) 00 GG 00 BB+RR+GG
		
			psrlw mm0, 8			// (np) 00 0G 00 0Y

			movd ebx, mm0			// (np) OCXP[Px(Y)

			movd mm0, [esi+ebx*4]	// (np) OCXP[J[擾

			movd mm1, [edi-4]		//  uh̃\[XRsy
			punpcklbw mm0, mm6		// OCXP[J[ 00 0R 0G 0B

			punpcklbw mm1, mm6		// ] - 0A 0R 0G 0B
			pmullw mm0, mm4

			pmullw mm1, mm5			// (np) 

			paddw mm0, mm1			// (np) 

			psrlw mm0, 8			// (np) 

			packuswb mm0, mm6		// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0		// ]
			jns loop_x0

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y0

			emms
		}

	}else
	{
		__asm
		{
			mov edi, pBits
			mov esi, lpMonoTbl

			mov ecx, nHeight			// X[vJE^
			pxor mm6, mm6

		loop_y1:

			or ecx, nWidth

		loop_x1:

			movd mm0, [edi]			// sNZf[^擾
			mov edx, [edi]

			punpcklbw mm0, mm6		// 0A 0R 0G 0B
			add edi, 4

			pmullw mm0, qwY_RGB		// 00 RR GG BB
			and edx, __Axxx_MASK

			movq mm1, mm0			// MM1 = 00 RR GG BB Rs[
			punpcklwd mm0, mm6		// MM0 = 00 GG 00 BB

			movq mm2, mm0			// MM2 = 00 GG 00 BB Rs[
			punpckhwd mm1, mm6		// MM1 = 00 00 00 RR

			paddd mm0, mm1			// 00 GG 00 BB+RR
			punpckhwd mm2, mm6		// MM2 = 00 00 00 GG

			paddd mm0, mm2			// 00 GG 00 BB+RR+GG

			psrlw mm0, 8			// (np) 00 0G 00 0Y
	
			movd ebx, mm0			// OCXP[Px(Y)

			or edx, [esi+ebx*4]		// OCXP[J[ | 
			sub ecx, __DEC_WIDTH

			mov [edi-4], edx		// AY YY]
			jns loop_x1

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗ZsA
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	BYTE Strengthc 0ŃtJ[A255ŊSmN
|	SDIB32GLCOLOR Colorc߂F@(ZsAcR=240 G=200 B=145)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::Sepia( int x, int y, int nWidth, int nHeight, BYTE Strength, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( Strength == 0 ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	nWidth  = CONVERT_WIDTH( nWidth );
	nHeight = CONVERT_HEIGHT( nHeight );

	static const DWORD64 qwY_RGB = 0x0000004d0097001c;
	static const DWORD64 qwAlphaMask = 0x0000000001000000;

	// pZsAϊe[u
	SDIB32GLCOLOR SepiaTbl[256];

	DWORD dwSepia[2] = 
	{
		CONVERT_255To256(SDIB32GL_GET_GREEN(Color))<<16 | CONVERT_255To256(SDIB32GL_GET_BLUE(Color)),
		CONVERT_255To256(SDIB32GL_GET_RED(Color))
	};

	LPSDIB32GLCOLOR lpMonoTbl = m_MonoTbl;

	// ZsAϊe[u쐬
	__asm
	{
		mov ecx, 255
		lea edi, SepiaTbl

		movq mm4, dwSepia
		pxor mm6, mm6

		mov esi, lpMonoTbl 

	loop_tbl:
		
		movd mm0, [esi+ecx*4]		// mNJ[擾

		punpcklbw mm0, mm6			// 00 0R 0G 0B

		pmullw mm0, mm4

		psrlw mm0, 8

		packuswb mm0, mm6
		dec ecx

		movd [edi+ecx*4+4], mm0
		jns loop_tbl
	}


	if( Strength != 255 )
	{
		DWORD dwStrength1 = CONVERT_255To256(Strength);
		DWORD dwStrength2 = DEST_ALPHA(dwStrength1);

		__asm
		{	
			movd mm4, dwStrength1			// 00  0				<u>
			mov edi, pBits					//						<v>

			movd mm5, dwStrength2			// 00  0(1-)			<u>
			mov ecx, nHeight				// X[vJE^		<v>

			movq mm0, mm4
			movq mm1, mm5
 
			por mm1, qwAlphaMask

			punpcklwd mm4, mm4				// 0 0
			punpcklwd mm5, mm5				// 0(1-) 0(1-)

			punpcklwd mm4, mm0				// 00 0 0 0
			punpcklwd mm5, mm1				// 01 0(1-) 0(1-) 0(1-)

			lea esi, SepiaTbl
			pxor mm6, mm6

		loop_y0:

			or ecx, nWidth

		loop_x0:

			movd mm0, [edi]			// sNZf[^擾
			mov edx, [edi]			// sNZf[^擾

			punpcklbw mm0, mm6		// 0A 0R 0G 0B
			add edi, 4

			pmullw mm0, qwY_RGB		// 00 RR GG BB
			and edx, __Axxx_MASK

			movq mm1, mm0			// MM1 = 00 RR GG BB Rs[
			punpcklwd mm0, mm6		// MM0 = 00 GG 00 BB

			movq mm2, mm0			// MM2 = 00 GG 00 BB Rs[
			punpckhwd mm1, mm6		// MM1 = 00 00 00 RR

			paddd mm0, mm1			// 00 GG 00 BB+RR
			punpckhwd mm2, mm6		// MM2 = 00 00 00 GG

			paddd mm0, mm2			// (np) 00 GG 00 BB+RR+GG
		
			psrlw mm0, 8			// (np) 00 0G 00 0Y

			movd ebx, mm0			// (np) OCXP[Px(Y)

			movd mm0, [esi+ebx*4]	// (np) OCXP[J[擾

			movd mm1, [edi-4]		//  uh̃\[XRsy
			punpcklbw mm0, mm6		// OCXP[J[ 00 0R 0G 0B

			punpcklbw mm1, mm6		// ] - 0A 0R 0G 0B
			pmullw mm0, mm4

			pmullw mm1, mm5			// (np) 

			paddw mm0, mm1			// (np) 

			psrlw mm0, 8			// (np) 

			packuswb mm0, mm6		// 00 00 AR GB
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0		// ]
			jns loop_x0

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y0

			emms
		}

	}else
	{
		__asm
		{
			mov edi, pBits
			lea esi, SepiaTbl

			mov ecx, nHeight			// X[vJE^
			pxor mm6, mm6

		loop_y1:

			or ecx, nWidth

		loop_x1:

			movd mm0, [edi]			// sNZf[^擾
			mov edx, [edi]

			punpcklbw mm0, mm6		// 0A 0R 0G 0B
			add edi, 4

			pmullw mm0, qwY_RGB		// 00 RR GG BB
			and edx, __Axxx_MASK

			movq mm1, mm0			// MM1 = 00 RR GG BB Rs[
			punpcklwd mm0, mm6		// MM0 = 00 GG 00 BB

			movq mm2, mm0			// MM2 = 00 GG 00 BB Rs[
			punpckhwd mm1, mm6		// MM1 = 00 00 00 RR

			paddd mm0, mm1			// 00 GG 00 BB+RR
			punpckhwd mm2, mm6		// MM2 = 00 00 00 GG

			paddd mm0, mm2			// 00 GG 00 BB+RR+GG

			psrlw mm0, 8			// (np) 00 0G 00 0Y
	
			movd ebx, mm0			// OCXP[Px(Y)

			or edx, [esi+ebx*4]		// OCXP[J[ | 
			sub ecx, __DEC_WIDTH

			mov [edi-4], edx		// AY YY]
			jns loop_x1

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y1

			emms
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗̖邳
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	int nBrightc邳 -255()`255()
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLPMMX::Bright( int x, int y, int nWidth, int nHeight, int nBright )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( nBright == 0 ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	nWidth  = CONVERT_WIDTH( nWidth );
	nHeight = CONVERT_HEIGHT( nHeight );

	nBright %= 256;

	// R[h͉ZAZƓ+`l󂳂Ȃ݌v

	if( nBright > 0 )
	{
		__asm
		{
			mov edi, pBits				// obt@
			mov ecx, nHeight			// X[vJE^

			mov eax, __Axxx_MASK
			mov ebx, __xRGB_MASK

			movd mm4, nBright
			mov edx, dwAddWidth

			movd mm5, eax
			punpcklbw mm4, mm4
			
			movd mm6, ebx
			punpcklwd mm4, mm4			// 00 00 bb bb

		loop_y_light:

			or ecx, nWidth

		loop_x_light:

			movd mm0, [edi]
			add edi, 4

			movq mm1, mm0
			paddusb mm0, mm4			// Z

			pand mm1, mm5				// A R G B & 1 0 0 0
			pand mm0, mm6				// A R G B & 0 1 1 1

			por mm0, mm1				// A 0 0 0 | 0 R G B
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0			// ]
			jns loop_x_light

			add edi, edx
			sub ecx, __DEC_HEIGHT

			jns loop_y_light

			emms
		}

	}else
	{
		nBright = -nBright;

		__asm
		{
			mov edi, pBits				// obt@
			mov ecx, nHeight			// X[vJE^

			mov eax, __Axxx_MASK
			mov ebx, __xRGB_MASK

			movd mm4, nBright
			mov edx, dwAddWidth

			movd mm5, eax
			punpcklbw mm4, mm4
			
			movd mm6, ebx
			punpcklwd mm4, mm4			// 00 00 bb bb

		loop_y_dark:

			or ecx, nWidth

		loop_x_dark:

			movd mm0, [edi]
			add edi, 4

			movq mm1, mm0
			psubusb mm0, mm4			// Z

			pand mm1, mm5				// A R G B & 1 0 0 0
			pand mm0, mm6				// A R G B & 0 1 1 1

			por mm0, mm1				// A 0 0 0 | 0 R G B
			sub ecx, __DEC_WIDTH

			movd [edi-4], mm0			// ]
			jns loop_x_dark

			add edi, edx
			sub ecx, __DEC_HEIGHT

			jns loop_y_dark

			emms
		}
	}

	return S_OK;
}